﻿function planteArbreDebut()
{
	etapeCA="planteDebut";
// on plante les arbres en automne
	saison=3;
	
	// oliviers
	var tentative=0;
	for (i=0;i<6;i++)
	{
		tentative++;
		var x=Math.round(Math.random()*(imax-6))+3;
		var y=Math.round(Math.random()*(jmax-6))+3;
		if ((alt_case(x,y)>180)&&(caseVide(x,y))&&(calcConc(x,y)<0.02))
		{
			var age=Math.floor(Math.random()*30+20);
			var espece=2;
			var variete=1;
			var cr=creeArbre (x,y,espece,variete,age);	
			if ((!cr)&&(tentative<200)) {i--;}
		}
		else
		{
			if (tentative<200)
			{i--;}
				
		}
	}	
	
	// pins
	var tentative=0;
	for (i=0;i<6;i++)
	{
		tentative++;
		var x=Math.round(Math.random()*(imax-6))+3;
		var y=Math.round(Math.random()*(jmax-6))+3;
		if ((alt_case(x,y)>120)&&(caseVide(x,y))&&(calcConc(x,y)<0.05))
		{
			var age=Math.floor(Math.random()*10+10);
			var espece=3;
			var variete=1;
			var cr=creeArbre (x,y,espece,variete,age);	
			if ((!cr)&&(tentative<200)) {i--;}
		}
		else
		{
			if (tentative<200)
			{i--;}
				
		}
	}
	
	// on vieillit et on fait grandir les arbres selon leurs âges
	var tAge=new Array();
	// on reset les âges des arbres après les avoir enregistrés dans tage
	for (var i=0;i<iobj[1].tpos.length;i++)
	{
		tAge[i]=iobj[1].tpos[i].age;
		iobj[1].tpos[i].age=0;
	}
	
	// on scanne un siècle à rebourd
	for (var a=100;a>0;a--)
	{
		// on ne fait vieillir que les arbres dont l'âge est suffisant
		for (var ida=0;ida<iobj[1].tpos.length;ida++)
		{
			if (tAge[ida]>=a)
			{
				saison=2;
				vieillitArbre(ida);
				saison=3;
				vieillitArbre(ida);
				saison=4;
				vieillitArbre(ida);
				saison=1;
				vieillitArbre(ida);
				calcFong(ida);
				calcInsectes(ida);
				calcVit(ida);
				if (iobj[1].tpos[ida].fong>0.1) {iobj[1].tpos[ida].fong=0.1;}
				if (iobj[1].tpos[ida].inse>0.1) {iobj[1].tpos[ida].inse=0.1;}	
			}
		}
	}
	
	// on remet la saison au printemps
	saison=1;
	// on recalcule tous les arbres
	
	recalcTousArbres (0);
}

function vieillitTousArbresSaison()
{
		var la=iobj[1].tpos.length;
		for (i=0;i<la;i++)
		{
			calcFong(i);
			calcInsectes(i);
			calcVit(i);
			vieillitArbre(i);
		}
}

function verifieLimites()
{
	var l=false;
	var x=0;
	var y=0;
	var io=iobj[1].tpos;
	var d=3;
	for (var i=0;i<io.length;i++)
	{
		x=io[i].x;
		y=io[i].y;
		if ((io[i].p)&&(!io[i].souche))
		{
			if ((x<d)||(y<d)||(x>(imax-d))||(y>(jmax-d)))
			{
				l=true;
			}
		}
	}
	return l;
}

function analyseArbre (ida)
{
	var t=iobj[1].tpos[ida];
	// recalcul de la concurrence
	var x=t.x;
	var y=t.y;
	iobj[1].tpos[ida].concurrence=calcConc(x,y);
	
	nQuestion=-4;
	
	enTeteQuestion();
	
	//dessin de l'arbre
	var ccanArbre=tCanvArbre[ida];
	
	var zoomFA=hautMax/t.haut*1.5;

	var lFenetreArbre=lcanvq/3;
	var hFenetreArbre=hcanvq*6/10;
	var lArbre=Math.round(lcanvarbre/zoomFA);
	var hArbre=Math.round(hFenetreArbre/lFenetreArbre*lArbre);
	var xArbre=Math.round(lcanvarbre/2-lArbre/2);
	var yArbre=hcanvarbre-hArbre;
	var yFenetreArbre=Math.round(hcanvq/10);

	if (yArbre>0) {ctxq.drawImage (ccanArbre,xArbre,yArbre,lArbre,hArbre,0,yFenetreArbre,lFenetreArbre,hFenetreArbre);}

	var	ht=Math.floor(hcanvq/24);
	ctxq.fillStyle="black";	
	ctxq.textAlign="left";

	ctxq.font = "bold "+ht*1.5+"px sans-serif";
	var texte1="Résultats de l'analyse de l'arbre";
	var yt=wrapText(ctxq, texte1, ht*3, ht*3, lcanvq-ht*6, ht*2);
	
	var x=lcanvq/3+ht;
	
	ctxq.font =ht+"px sans-serif";
	var texte1="Espèce : ";
	if (t.espece==1) {texte1+="cerisier (Prunus avium)";}
	if (t.espece==2) {texte1+="olivier (Olea europaea)";}
	if (t.espece==3) {texte1+="pin d'Alep (Pinus halepensis)";}
	var yt=wrapText(ctxq, texte1, x, yt+ht*3, lcanvq-ht*6, ht*2);
	
	texte1="Age : "+Math.round(t.age)+" ans";
	var yt=wrapText(ctxq, texte1, x, yt+ht*2, lcanvq-ht*6, ht*2);

	couleur="117711";
	if (t.vit<0.7) {couleur="BB9933";}
	if (t.vit<0.4) {couleur="BB3333";}	
	texte1="Vitalité : "+Math.round(t.vit*100)+"%";
	var yt=wrapText(ctxq, texte1, x, yt+ht*2, lcanvq-ht*6, ht*2);
	
	couleur="117711";
	if (t.concurrence>0.3) {couleur="BB9933";}
	if (t.concurrence>0.7) {couleur="BB3333";}	
	texte1="Concurrence : "+Math.round(t.concurrence*100)+"%";
	var yt=wrapText(ctxq, texte1, x, yt+ht*2, lcanvq-ht*6, ht*2);
		
	couleur="117711";
	var pcFong=Math.round(t.fong*100);
	if (t.fong<=0.05) {texte1="Pas de maladie fongique";} else {texte1="Infesté à "+pcFong+"% par une maladie fongique";}
	if (t.fong>0.2) {couleur="BB9933";}
	if (t.fong>0.6) {couleur="BB3333";}
	ctxq.fillStyle="#"+couleur;
	var yt=wrapText(ctxq, texte1, x, yt+ht*2, lcanvq-ht*6, ht*1.5);
	
	couleur="117711";
	var pcInse=Math.round(t.inse*100);
	if (t.inse>0.4) {couleur="BB9933";}
	if (t.inse>0.8) {couleur="BB3333";}
	ctxq.fillStyle="#"+couleur;
	if (t.inse<0.05) {texte1="Pas d'infestation par des insectes";} else {texte1="Infesté à "+pcInse+"% par des insectes";}
	var yt=wrapText(ctxq, texte1, x, yt+ht*2, lcanvq-ht*6, ht*1.5);
}

function compteArbre(espece)
{
	var n=0;
	var t=iobj[1].tpos;
	for (var i=0;i<t.length;i++)
	{
		if ((t[i].espece==espece)&&(t[i].etat>0))
		{n++;}
	}
	return n;
}

function ensemencePin ()
{
	if (Math.random()>0.25) {return false;} // on n'ensemence qu'une saison fertile sur 4
	var x=Math.floor(Math.random()*imax);
	var y=Math.floor(Math.random()*jmax);
	if ((alt_case(x,y)>120)&&(calcConc(x,y)<0.1)&&(caseVide(x,y)))
	{
		var espece=3;
		var variete=1;
		var age=1;
		creeArbre (x,y,espece,variete,age);
	}
}

function degatsMoutons()
{
	if (!berger) {return false;}
	for (var i=0;i<iobj[1].tpos.length;i++)
	{
		var t=iobj[1].tpos[i];
		if ((t.p)&&(!t.souche))
		{
			var haut=t.haut;
			if (haut<400)
			{
				var proba=(400-haut)/1000;
				if (Math.random()<proba)
				{
					messageTemp("Un arbrisseau a été mangé","par un mouton !",3);
					tronconne(t.ida);
				}
			}
		}//fin arbre présent et pas déjà en souche
	}//next i
	
}

function degatsSangliers()
{
	if (!sanglier) {return false;}
	for (var i=0;i<iobj[1].tpos.length;i++)
	{
		var t=iobj[1].tpos[i];
		if ((t.p)&&(!t.souche))
		{
			var haut=t.haut;
			if (haut<400)
			{
				var proba=(400-haut)/1000;
				if (Math.random()<proba)
				{
					messageTemp("Un arbrisseau a été détruit","par un sanglier !",3);
					tronconne(t.ida);
				}
			}
		}//fin arbre présent et pas déjà en souche
	}//next i
	
}

function recolter()
{
	compteRuches();
	if (saison==2) {recolterMiel();recolterCerises();return true;}
	if (saison==4) {recolterOlives();return true;}
}

function recolterCerises ()
{
		if ((saison!=2)||(!menu1[7].dispo)) {return false;}
		document.body.style.cursor="wait";
		var la=iobj[1].tpos.length;
		var totalFruits=0;
		var nbCerisiers=0;
		for (i=0;i<la;i++)
		{
			var espece=iobj[1].tpos[i].espece;
			if (espece==1)
			{
				nbCerisiers++;
				var f=iobj[1].tpos[i].fruits;
				var vit=iobj[1].tpos[i].vit;
				var haut=iobj[1].tpos[i].haut;
				var age=iobj[1].tpos[i].age;
				if (f>0) // cerisier
				{
					var recolteArbre=haut*coefNitrates*f/10;
					recolteArbre=recolteArbre*(1-pOiseaux/2);
					totalFruits+=recolteArbre*Math.random()*4+Math.random()*10;
				}
				iobj[1].tpos[i].fruits=0;
			}
		}
		//bonus abeilles
		var nbRuchesEffectives=nbRuches/(1+insecticides+desherbant);
		totalFruits=totalFruits*(1+(nbRuchesEffectives*0.1));
		
		//arrondi
		totalFruits=Math.round(totalFruits);
		if (totalFruits==0) 
		{
			if ((saison==2)&&(nbCerisiers==0)&&(annee==1))
			{
				messageTemp("Commencez par planter","des cerisiers.",3);
			}
			else
			{
				messageTemp("Pas de récolte de cerises","cette année",3);
			}
		}
		else
		{
			var texte1=totalFruits+" kg de cerises récoltées";
			messageTemp(texte1,"",3)
		}

		argent+=totalFruits*5; // 5 euros le kg ?
		revRec+=totalFruits*5;
		menu1[7].dispo=false;
		if (etapeCA!="saison")
		{
			recalcTousArbres (1);
		}
		affiche();
		rafrOverlay();
		document.body.style.cursor="default";
}

function recolterOlives ()
{
		if ((saison!=4)||(!menu1[7].dispo)) {return false;}
		document.body.style.cursor="wait";
		var la=iobj[1].tpos.length;
		var totalFruits=0;
		for (i=0;i<la;i++)
		{
			var espece=iobj[1].tpos[i].espece;
			if (espece==2) //olivier
			{
				var f=iobj[1].tpos[i].fruits;
				var vit=iobj[1].tpos[i].vit;
				var haut=iobj[1].tpos[i].haut;
				var age=iobj[1].tpos[i].age;
				if (f>0) 
				{
					var recolteArbre=haut*coefNitrates*f/8;
					recolteArbre=recolteArbre*Math.sqrt((1-pOiseaux/2)); // les oiseaux mangent moins les olives
					totalFruits+=recolteArbre*Math.random()+Math.random()*2;
				}
			}
			iobj[1].tpos[i].fruits=0;
		}
		totalFruits=Math.round(totalFruits);
		if (totalFruits==0) {messageTemp("Pas de récolte d'olives","cette année",3);}
		else
		{
			var texte1=totalFruits+" kg d'olives récoltées";
			messageTemp(texte1,"",3)
		}
		
		argent+=totalFruits*3; // 3 euros le kg ?
		revRec+=totalFruits*3;
		menu1[7].dispo=false;
		if (etapeCA!="saison")
		{
			recalcTousArbres (2);
		}
		affiche();
		rafrOverlay();
		document.body.style.cursor="default";
}

function tronconne (ida)
{
	aucuneAction=false;
	iobj[1].tpos[ida].souche=true;
	iobj[1].tpos[ida].vit=0;
	// tronçonné => champi divisés par 10
	iobj[1].tpos[ida].fong=iobj[1].tpos[ida].fong/10;
	// si l'arbre ne l'était pas déjà il est tué
	if (iobj[1].tpos[ida].etat>0) {iobj[1].tpos[ida].etat=-2;}
	
	recalcArbre(ida);
	afficheObjets();
}

function arrache (ida)
{
	aucuneAction=false;
	var id=1; // c'est un arbre !
	var h=iobj[1].tpos[ida].haut;
	var prixArrache=Math.round(h/hautMax*200+20);
	argent-=prixArrache;
	depenses+=prixArrache;
	
	supprObjet(id,ida);
	iobj[1].tpos[ida].p=false;
	iobj[1].tpos[ida].etat=0;
	iobj[1].tpos[ida].vit=0;
	iobj[1].tpos[ida].fong=0;
	iobj[1].tpos[ida].haut=0;
	iobj[1].tpos[ida].age=0;
	messageTemp("Arbre arraché","pour "+prixArrache+"€",1.5);
	afficheObjets();
}

function traitAntifongique (ida)
{
	aucuneAction=false;
	fongicides+=1;
	pesticidesEau+=0.1;
	var t=iobj[1].tpos[ida];
	t.fong=t.fong/10;
	t.fruits=0;
	bouillie=true;
	iobj[1].tpos[ida]=t;
	//messageTemp("Arbre traité","",1.5);
	recalcArbre(ida);
	afficheObjets();
	
}

function traitInsecticide (ida)
{
	aucuneAction=false;
	insecticides+=1.9;
	pesticidesEau+=0.2;
	var t=iobj[1].tpos[ida];
	t.inse=0;
	t.fruits=0;
	flytox=true;
	iobj[1].tpos[ida]=t;
	//messageTemp("Arbre traité","",1.5);
	recalcArbre(ida);
	afficheObjets();
	testApiFurieux();	
}

function bruleArbre (ida)
{
	iobj[1].tpos[ida].etat=-1;
	iobj[1].tpos[ida].fong=0.25;
	iobj[1].tpos[ida].vit=0;
	recalcArbre(ida);
	afficheObjets();
}
	
function granditArbre(ida)
{
	var t=iobj[1].tpos[ida];
	var age=t.age;
	var etat=t.etat;
	
	if (etat<0) {return false; }
	
	//console.log ('arbre '+ida+' grandi');
	
	var espece=t.espece;
	var vit=t.vit;
	var hautArbre=t.haut;
	
	if (saison<3)
	{
		if (espece==1)
		{
			var coef2=(hautArbre+hautMax/8)/(hautMax+hautMax/8);
			coef2=Math.pow(coef2,1.7);
			coef=1-coef2;
			coef=coef*100;
		}
		if (espece==2) //olivier
		{
			var coef2=(hautArbre+hautMax/8)/(hautMax+hautMax/8);
			coef2=Math.pow(coef2,1.6);
			coef=1-coef2;
			coef=coef*60;
		}
		if (espece==3)
		{
			var coef2=(hautArbre+hautMax/8)/(hautMax+hautMax/8);
			coef2=Math.pow(coef2,1.8);
			coef=1-coef2;
			coef=coef*100;
		}
		//if (ida==1) {console.log ("coef="+coef+" haut="+hautArbre)};
		var alea=Math.random()/2+0.9;
		//alea=1;
		//vit=1;
		
		var croissance=vit*coef*coefNitrates*alea;
			
		hautArbre+=croissance;
		nitratesSol-=croissance/1000;
		if (nitratesSol<30) {nitratesSol=30;}
	}

	var epTronc=calcEpTronc(espece,age,hautArbre);
			
	iobj[1].tpos[ida].haut=hautArbre;
	iobj[1].tpos[ida].epTronc=epTronc;
}

function calcFong(ida)
{
	var t=iobj[1].tpos[ida];
	var fong=t.fong;
	var vit=t.vit;
	var espece=t.espece;
	var a=alt_case(t.x,t.y);
	if ((fong<0.001)&&(a>0))
	{
		var proba=Math.sqrt(1/(a+10))/5;
		if (Math.random()<proba)
		{
			fong=0.05;
		}
	}
	
	if ((fong>0.3)&&(premierFong))
	{
		premierFong=false;
		messageTemp("Des feuilles de couleur anormale","indiquent une maladie fongique.",4);
		messageTemp("Ces maladies (causées par des","champignons) peuvent-être traitées.",3);
	}
		
	if (sanglier) {fong+=0.02;} // les sangliers aggravent les maladies fongiques
	
	if (fong>0.1) {fong+=0.02;}
	if ((fong>0.01)&&(fong<=0.1)) {fong+=0.01;}
	
	// si l'arbre pète la forme il peut guérir
	if (espece==1)
	{
		if (vit>0.4)
		{
			proba=vit-0.4;
			if (Math.random()<proba)
			{
				fong-=0.2;
				if (fong<0)
				{
					fong=0;
				}
			}
		}
	}
	if (espece==2)
	{
		if (vit>0.3)
		{
			proba=vit-0.3;
			if (Math.random()<proba)
			{
				fong-=0.3;
				if (fong<0)
				{
					fong=0;
				}
			}
		}
	}
	
	if (a<0) {fong+=Math.random()/4;}	
	if ((t.etat>0)&&(fong>=1)) {
		fong=1;
		t.etat=-4;
		t.vit=0;
	}
	
	if (fong>1)
	{
		fong=1;
	}
	
	// si l'arbre est tronçonné on limite à 0.1
	if ((t.souche)&&(fong>0.1))
	{
		fong=0.1;
	}
	
	// les pins vivants sont épargnés
	if ((espece==3)&&(vit>0))
	{
		fong=fong/20;
	}
	
	t.fong=fong;
		
	iobj[1].tpos[ida]=t;
}
	
function calcConc(x,y)
{
	var concurrence=0;
	var rMax=15;
	var prelev=0;
	var prelev1=0;
	var prelev2=0;
	var d=0;
	for (var i=-rMax;i<=rMax;i++)
	{
		for (var j=-rMax;j<=rMax;j++)
		{
			prelev1=0;
			prelev2=0;
			d=i*i+j*j;
			d=Math.pow(d,0.8);
			if (d>0)
			{
				var ii=x+i;
				var jj=y+j;
				
				if ((ii>=0)&&(jj>=0)&&(ii<=imax)&&(jj<=jmax))
				{
					var ch=tobj[ii][jj];
					
					if (ch.id==1) // arbre
					{
						var t2=iobj[1].tpos[ch.ida];
						if ((t2.etat>0)&&(t2.p))
						{
							prelev1=((t2.haut*t2.vit)/d);
						}
					}
					
					if (ch.id==2) // buisson
					{
						var t3=iobj[2].tpos[ch.ida];
						if ((t3.etat>0)&&(t3.p))
						{
							prelev2=t3.taille/d;
						}
					}
					prelev=prelev1/80+prelev2/30;
					concurrence+=prelev;
				}//  ii>0 etc ...
			}// d>0
		}// next j
	}//next i
	
	return concurrence;
}
	
function calcVit(ida)
{
	var t=iobj[1].tpos[ida];
	var age=t.age;
	var espece=t.espece;
	var etat=t.etat;
	var s=t.s;
	var x=t.x;
	var y=t.y;
	var present=t.p;
	var fong=t.fong;
	var vit0=t.vit;
	var fong=t.fong;
	var inse=t.inse;
	if ((vit0<=0)||(etat<0)||(!present))
	{
		return false;
	}

	var sommeFong=0;
	var rMax=10;
	
	var concurrence=calcConc(x,y);

	for (var i=-rMax;i<=rMax;i++)
	{
		for (var j=-rMax;j<=rMax;j++)
		{
			var d=i*i+j*j;
			d=Math.pow(d,0.8);
			if (d>0)
			{
				var ii=x+i;
				var jj=y+j;
				
				if ((ii>=0)&&(jj>=0)&&(ii<=imax)&&(jj<=jmax))
				{
					var ch=tobj[ii][jj];
					
					if (ch.id==1) 
					{
						var t2=iobj[1].tpos[ch.ida];
						if (t2.p)
						{
							if (t2.espece==espece) {sommeFong+=(t2.haut/hautMax)*t2.fong/d/2;} //contagion seulement même espèce
						}
					}
				}// ii>0 etc ...
				
			}// d>0
		}// next j
	}//next i

	//contagion fongique ?
	var proba=1-Math.exp(-sommeFong);
	if ((Math.random()<proba)&&(fong<0.05))
	{
		console.log ('un arbre a été contaminé par un autre');
		fong=0.05;
	}
	
	//recalcul de la vitalité
	vit=Math.exp(-concurrence)*Math.sqrt(coefNitrates);
	
	
	// l'olivier n'aime vraiment pas l'eau
	var racinesAuSec=1;
	if (espece==2)
	{
		var a=alt_case(x,y)/30;
		if (a<1) {a=1;}
		racinesAuSec=(1-1/a)+0.1;
		if (racinesAuSec>1) {racinesAuSec=1;}
		
		vit=vit*racinesAuSec;
		//console.log ("Au sec ("+t.x+","+t.y+")="+racinesAuSec);
	}
	
	// le cerisier tolère
	if (espece==1)
	{
		var a=alt_case(x,y)/15;
		if (a<1) {a=1;}
		racinesAuSec=(1-1/a)+0.2;
		if (racinesAuSec>1) {racinesAuSec=1;}
		
		vit=vit*racinesAuSec;
		//console.log ("Au sec ("+t.x+","+t.y+")="+racinesAuSec);
	}
	
	//console.log("concurrence="+concurrence+"vitalité="+vit);
	vit=vit*(1-fong);
	
	//les insectes 
	var coefInsectes=t.inse-0.6;
	if (coefInsectes<0) {coefInsectes=0;}
	coefInsectes=1-(coefInsectes/2);
	vit=vit*coefInsectes;
	
	//on moyenne avec l'ancienne vitalité
	vit=(vit0*3+vit)/4;
	
	vit=vit+0.1-Math.random()/5;
	if (vit<=0.05)
	{
		//console.log ('un arbre est mort du fait de sa faible vitalité');
		if (racinesAuSec<0.5) {messageTemp("Un arbre est mort","les racines asphyxiées par l'eau.",3);}
		else if (fong<0.3) {messageTemp("Un arbre est mort pour avoir","trop souffert de la concurrence.",3);}
		else {messageTemp("Un arbre est mort des suites","d'une maladie fongique.",3);}
		
		vit=0;
		iobj[1].tpos[ida].etat=-3;
	}
	
	iobj[1].tpos[ida].vit=vit;
	iobj[1].tpos[ida].concurrence=concurrence;
	
	iobj[1].tpos[ida].fong=fong;
}
	
function calcHautArbre(espece)
{
	if (espece==1)
	{
		h=Math.random()*5+20;
	}
	if (espece==2)
	{
		h=Math.random()*3+15;
	}
	if (espece==3)
	{
		h=Math.random()*7+25;
	}
	
	//if (h>hautMax)
	//{h=hautMax;}
	return h;
}


function calcProfArbre(espece,haut)
{
	if (espece==1)
	{
	var p1=Math.sqrt(haut/hautMax)*profMax;
	var p2=0;
	var p3=1;
	}
	if (espece==2)
	{
	var p1=Math.sqrt(haut/(hautMax/2))*profMax;
	var p2=0;
	var p3=1;	
	}
	if (espece==3)
	{
	var p1=Math.sqrt(haut/hautMax)*profMax;
	var p2=0;
	var p3=2;
	}
	
	profArbre=p1+p2+p3;
	if (profArbre>profMax)
	{
		profArbre=profMax;
	}
	
	return Math.round(profArbre);
}

function calcEpTronc(espece,age,haut)
{
	var epMax=100;
	if (espece==1)
	{
		var epTronc=Math.pow(haut,0.75)/10+age/3;
	}
	if (espece==2)
	{
		var epTronc=Math.pow(haut,0.8)/10+age/5;
	}
	if (espece==3)
	{
		var epTronc=Math.pow(haut,0.75)/10+age/5;
	}
	if (epTronc<1) {epTronc=1;}
	if (epTronc>epMax) {epTronc=epMax;}
	return epTronc;
}

function calcCoul (espece,age,etat)
{
	//feuilles
	if (espece==1)
	{
		//cerisier
		if (saison==1)
		{
			coulFeuilles="#559933";
			coulFeuilles2="#448822";
			coulFeuillesMalades="#888822";
		}
		if (saison==2)
		{
			coulFeuilles="#006600";
			coulFeuilles2="#005500";
			coulFeuillesMalades="#666600";
		}
		if (saison==3)
		{
			coulFeuilles="#774400";
			coulFeuilles2="#663300";
			coulFeuillesMalades="#221100";
		}
	}
	if (espece==2)
	{
		//olivier
		coulFeuilles="#005544";
		coulFeuilles2="#004433";
		coulFeuillesMalades="#666600";
	}
	if (espece==3)
	{
		//pin
		coulFeuilles="#003300";
		coulFeuilles2="#002200";
		coulFeuillesMalades="#333300";
	}
	
	// couleur du tronc
	if (espece==1)
	{
		//cerisier
		var r=Math.round(50+aleasr(20)-age/20);
		if (r<20) {r=20;}
		var g=Math.round(20+aleasr(10)-age/20);
		var b=Math.round(10+age/20);
		if (b>(r/2))
		{
			b=Math.round(r/2);
		}
		coulTronc=rgbToHex(r,g,b);
		coulTronc2=rgbToHex(Math.round(r*1.2+10),Math.round(g*1.15+3),(b+5));
		coulTronc3=rgbToHex(Math.round(r*1.3+15),Math.round(g*1.3+6),(b+10));
	}
	if (espece==2)
	{
		//olivier
		var r=Math.round(50+aleasr(20)-age/20);
		if (r<20) {r=20;}
		var g=r;
		var b=r;
		coulTronc=rgbToHex(r,g,b);
		coulTronc2=rgbToHex(Math.round(r*1.2+10),Math.round(g*1.15+3),(b+5));
		coulTronc3=rgbToHex(Math.round(r*1.3+15),Math.round(g*1.3+6),(b+10));
	}
	if (espece==3)
	{
		//pin
		var r=Math.round(50+aleasr(20)-age/10);
		if (r<10) {r=10;}
		var g=r;
		var b=r;
		coulTronc=rgbToHex(r,g,b);
		coulTronc2=rgbToHex(Math.round(r*1.1),Math.round(g*1.1),Math.round(b*1.1));
		coulTronc3=rgbToHex(Math.round(r*1.2),Math.round(g*1.2),Math.round(b*1.2));
	}		
	

	
	if (etat==-1)
	{coulTronc="#000000";coulTronc2="#222222";coulTronc3="#333333";}
	
	if (espece==1) //cerises
	{
		coulFruits="#770000";
	}
	else
	{
		//olives
		if (saison==3) {coulFruits="#004422";}
		if (saison==4) {coulFruits="#221133";}

	}

	if (flytox)
	{
		flytox=false;
		coulFeuilles="#999966";
		coulFeuilles2="#999955";
		coulFeuillesMalades="#999977";
		coulTronc="#444411";
		coulTronc2="#555522";
		coulTronc3="#666633";
	}
	
	if (bouillie)
	{
		bouillie=false;
		coulFeuilles="#666699";
		coulFeuilles2="#555599";
		coulFeuillesMalades="#777799";
		coulTronc="#111133";
		coulTronc2="#222244";
		coulTronc3="#332255";
	}
}

//function recalcTousArbres (e)
//{
//	for (var i=0;i<iobj[1].tpos.length;i++)
//	{
//		if ((iobj[1].tpos[i].espece==e)||(e==0)) 
//		{recalcArbre (iobj[1].tpos[i].ida);}
//	}
//}

function apresCalcul()
{
	messageEtat ('calcul arbres terminé',2);
	if (etapeCA=="saison")
	{
		bilanSaison();
	}
	
	if (etapeCA=="planteDebut")
	{
		creeHerbe();	
		creeFleurs();
		creeOiseauxDebut();
		planteBuissonsDebut ();
		lessiver();
		affiche();
		lanceAccueil();
	}
}

function doRecalcArbre(e,i)
{
	if (i<iobj[1].tpos.length)
	{
		//messageEtat ('calcul arbre '+i,2);
		
		progres ((i+1)/iobj[1].tpos.length);
		setTimeout(function(){
			if ((iobj[1].tpos[i].espece==e)||(e==0)) 
			{
				recalcArbre (iobj[1].tpos[i].ida);
			}
			doRecalcArbre (e,i+1);
		},0);
		
	}
	else
	{
		apresCalcul();
		return true;
	}
}

function recalcTousArbres(e)
{
	doRecalcArbre(e,0);
}

function recalcArbre (ida)
{
	//console.log ('recalcArbre etape='+etapeCA);
	var t=iobj[1].tpos[ida];
	if (!t.p) {return false;}
		
	var age=t.age;
	var vit=t.vit;
	var hautArbre=t.haut;
	var etat=t.etat;
	var fong=t.fong;
	var inse=t.inse;
	var s=t.s;
	var fruits=t.fruits;
	var fleurs=t.fleurs;
	var souche=t.souche;
	var espece=t.espece;
	var epTronc=t.epTronc;
	
	// on recrée l'arbre
	//console.log ('recree '+ida);
	var ccanArbre=tCanvArbre[ida];
	ctxArbre=ccanArbre.getContext("2d");
	ctxArbre.clearRect(0,0,ccanArbre.width,ccanArbre.height);
	
	seed=s;
	calcCoul(espece,age,etat);	
	
	var profArbre=calcProfArbre(espece,hautArbre);

	var xx=lcanvarbre/2;
	var yy=hcanvarbre-epTronc*0.25*1.2;
	if (souche)
	{
		ctxArbre.save();
		ctxArbre.translate(xx,yy);
		ctxArbre.scale (1,0.5);

		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc;
		ctxArbre.arc(0,0,epTronc*0.5*1.2,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		
		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc2;
		ctxArbre.arc(0,0,epTronc*0.4*1.2,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		
		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc3;
		ctxArbre.arc(0,0,epTronc*0.2*1.2,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		ctxArbre.restore();
	
		ctxArbre.fillStyle=coulTronc;
		ctxArbre.fillRect (xx-epTronc/2,yy-epTronc,epTronc,epTronc);
		ctxArbre.fillRect (xx-epTronc/2*1.1,yy-epTronc/2,epTronc*1.1,epTronc/2);
		ctxArbre.fillRect (xx-epTronc/2*1.2,yy-epTronc/8,epTronc*1.2,epTronc/8);
		ctxArbre.fillStyle=coulTronc2;
		ctxArbre.fillRect (xx-epTronc*0.4,yy-epTronc,epTronc*0.4*2,epTronc);
		ctxArbre.fillRect (xx-epTronc*0.4*1.1,yy-epTronc/2,epTronc*0.4*2*1.1,epTronc/2);
		ctxArbre.fillRect (xx-epTronc*0.4*1.2,yy-epTronc/8,epTronc*0.4*2*1.2,epTronc/8);
		ctxArbre.fillStyle=coulTronc3;
		ctxArbre.fillRect (xx-epTronc*0.2,yy-epTronc,epTronc*0.2*2,epTronc);
		ctxArbre.fillRect (xx-epTronc*0.2*1.1,yy-epTronc/2,epTronc*0.2*2*1.1,epTronc/2);
		ctxArbre.fillRect (xx-epTronc*0.2*1.2,yy-epTronc/8,epTronc*0.2*2*1.2,epTronc/8);
		ctxArbre.save();
		ctxArbre.translate(xx,yy-epTronc);
		ctxArbre.scale (1,0.5);
		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc;
		ctxArbre.arc(0,0,epTronc/2,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc2;
		ctxArbre.arc(0,0,epTronc*0.4,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc3;
		ctxArbre.arc(0,0,epTronc*0.2,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		ctxArbre.restore();
		return false;
	
	}
	
	
	dessineFeuilles=true;
	if ((etat<0)||((saison==4)&&(espece==1))){dessineFeuilles=false;}
	
	if (espece==1)
	{
		tailleFeuilles=40;
	}
	if (espece==2)
	{
		tailleFeuilles=20;
	}
	if (espece==3)
	{
		tailleFeuilles=10;
	}
	
	tailleFruits=40;
	
	if ((saison==1)&&(espece==1))
	{
		tailleFeuilles=tailleFeuilles/2;
	}
	
	seed=s;
	ctxArbre.save();
	
	var inse2=inse-0.5;
	if (inse2<0) {inse2=0;}
	
	if (espece==1)
		{cerisier.dessine(hcanvas,lcanvas,xx,yy,hautArbre,fleurs,fruits,fong,inse2,profArbre,epTronc,s);}
	if (espece==2)
		{olivier.dessine(hcanvas,lcanvas,xx,yy,hautArbre,fleurs,fruits,fong,inse2,profArbre+1,epTronc,s);}
	if (espece==3)
		{pin.dessine(hcanvas,lcanvas,xx,yy,hautArbre,false,fruits,fong,inse2,profArbre,epTronc,s);}
		
	ctxArbre.restore();
	
	if (!souche)
	{
			
		ctxArbre.save();
		ctxArbre.translate(xx,yy);
		ctxArbre.scale (1,0.5);

		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc;
		ctxArbre.arc(0,0,epTronc*0.5*1.2,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		
		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc2;
		ctxArbre.arc(0,0,epTronc*0.4*1.2,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		
		ctxArbre.beginPath();
		ctxArbre.fillStyle=coulTronc3;
		ctxArbre.arc(0,0,epTronc*0.2*1.2,0,Math.PI*2);
		ctxArbre.closePath();
		ctxArbre.fill();
		ctxArbre.restore();
	
		ctxArbre.fillStyle=coulTronc;
		ctxArbre.fillRect (xx-epTronc/2,yy-epTronc,epTronc,epTronc);
		ctxArbre.fillRect (xx-epTronc/2*1.1,yy-epTronc/2,epTronc*1.1,epTronc/2);
		ctxArbre.fillRect (xx-epTronc/2*1.2,yy-epTronc/8,epTronc*1.2,epTronc/8);
		ctxArbre.fillStyle=coulTronc2;
		ctxArbre.fillRect (xx-epTronc*0.4,yy-epTronc,epTronc*0.4*2,epTronc);
		ctxArbre.fillRect (xx-epTronc*0.4*1.1,yy-epTronc/2,epTronc*0.4*2*1.1,epTronc/2);
		ctxArbre.fillRect (xx-epTronc*0.4*1.2,yy-epTronc/8,epTronc*0.4*2*1.2,epTronc/8);
		ctxArbre.fillStyle=coulTronc3;
		ctxArbre.fillRect (xx-epTronc*0.2,yy-epTronc,epTronc*0.4,epTronc);
		ctxArbre.fillRect (xx-epTronc*0.2*1.1,yy-epTronc/2,epTronc*0.4*1.1,epTronc/2);
		ctxArbre.fillRect (xx-epTronc*0.2*1.2,yy-epTronc/8,epTronc*0.4*1.2,epTronc/8);
	}

}

function vieillitArbre (ida)
{
	var t=iobj[1].tpos[ida];
	var etat=t.etat;
	var vit=t.vit;
	if (etat<0) {return false;}
	var age=t.age;
	
	//console.log ('arbre '+ida+' vieilli');
	
	var s=t.s;
	
	age+=0.25;
	t.age=age;
	
	if ((saison==1)&&(vit*age>2))
	{t.fleurs=1;} else {t.fleurs=0;}
	
	var coefInsectes=t.inse-0.4;
	if (coefInsectes<0) {coefInsectes=0;}
	coefInsectes=1-coefInsectes;
	
	if (t.espece==1) //cerises ?
	{
		if ((saison==2)&&(vit*age>2))
		{t.fruits=vit*coefNitrates*coefInsectes;} else {t.fruits=0;}
	}
	if (t.espece==2) //olives ?
	{
		if ((saison>2)&&(vit*age>3))
		{t.fruits=vit*coefNitrates*coefInsectes;} else {t.fruits=0;}
	}	
	
	iobj[1].tpos[ida]=t;
	
	if (saison<3) {granditArbre (ida);}
}
 
function creeArbre (x,y,espece,variete,age)
{
	if ((x<1)||(x>=imax)||(y<1)||(y>=jmax)) {return false;}//pas sur les limites
	if (tobj[x][y].id==1) {messageTemp("Il y a déjà un arbre ici ...","",1.5);return false;}//déjà unarbre
	if (!caseVide(x,y)) {messageTemp("Cette zone est encombrée ...","",1.5);return false;}//déjà unarbre
	if (alt_case(x,y)<0) {messageTemp("Vous ne pouvez pas planter sous l'eau ...","",1.5);return false;}

	var t=new Object;
	var la=iobj[1].tpos.length;
	var ida=la;
	
	//console.log ("arbre "+ida+" créé");
	
	var s=Math.round(Math.random()*10000)+10;
	// la vitalité initiale dépend de la saison de plantation
	if (saison==1) {var vit=0.5;}
	if (saison==2) {var vit=0.2;}
	if (saison==3) {var vit=1;}
	if (saison==4) {var vit=0.5;}
	
	var fong=0;
	var etat=1;
	var inse=Math.random()*0.1;
	t.id=1;
	t.ida=ida; // numéro de l'arbre et donc du CanvArbre
	
	tobj[x][y]=t;
	
	var hautArbre=calcHautArbre(espece)*10;
	
	//console.log ("arbre créé en "+x+" "+y);
	
	iobj[1].tpos.push({x:x,y:y,ida:ida,s:s,espece:espece,age:age,etat:etat,haut:hautArbre,vit:vit,fong:fong,inse:inse,souche:false,fruits:0,fleurs:0,p:true}); //etat>0 => vivant etat<0 => mort (-1:brulé, -2:troncçonné)
	
	granditArbre(ida);
	calcFong(ida);
	calcInsectes(ida);
	calcVit(ida);
	
	//console.log ('canvas '+la+' créé');	
	tCanvArbre[la]=document.createElement('canvas');
		
	// création de l'arbre
	var ccanArbre=tCanvArbre[la];
	ctxArbre=ccanArbre.getContext("2d");
	
	ctxArbre.canvas.width  = lcanvarbre;
	ctxArbre.canvas.height = hcanvarbre;
	
	if (etapeCA!="planteDebut")
	{
		recalcArbre (ida);
	}
	return true;
}
