﻿function demarrer()
{
	charge ('communes');
	charge ('menu');
	charge ('score');
	charge ('question');
	charge ('clavier');
	charge ('temps');
	charge ('anime');
	charge ('gazon');
	charge ('arbre');
	charge ('buissons');
	charge ('oiseaux');
	charge ('insectes');
	charge ('algo_arbres');
	charge ('eau');
	charge ('sol');
	charge ('incendie');
	charge ('bouge_carte');
	charge ('gest_objets');
	charge ('fleurs');
	charge ('rafr_overlay');
}


function initialise()
{
	//bilanFinancier ();
	//return false;
	// évènement molette souris
	if (ccan2.addEventListener) {
		// IE9, Chrome, Safari, Opera
		ccan2.addEventListener("mousewheel", MouseWheelHandler, false);
		// Firefox
		ccan2.addEventListener("DOMMouseScroll", MouseWheelHandler, false);
		ccan2.addEventListener("mousedown", clicMenu,false);
		ccan2.addEventListener("mouseup", mouseUp,false);
		ccan2.addEventListener("mousemove", bouge_carte,false);
	}
	// IE 6/7/8
	else 
	{
		ccan2.attachEvent("onmousewheel", MouseWheelHandler);
		ccan2.attachEvent("onmousedown", clicMenu);
		ccan2.attachEvent("onmouseup", mouseUp);
		ccan2.attachEvent("onmousemove", bouge_carte);
	}
	
	scoreAffiche=0;
	canvscore.style.display="none";
	myCanvas.style.display="block";
	
	creeCanvasBuissons ();
	
	prepare_gazon ();
	
	planteArbreDebut();
	

}

function lanceAccueil()
{
	demar=true;
	etapeCA="";
	timerAnim=setInterval(function(){anime()},1000/fps);
	messageTemp("Bienvenue dans Sim'agro","",3);
	messageTemp("Maintenez le bouton gauche enfoncé","pour vous déplacer sur la carte.",3);
	messageTemp("Utilisez la roulette de la souris","pour zoomer sur la carte.",3);	
	
	ecranDAccueil();
}

function etape_suivante()
{
	etape++;

	if (etape>19)
	{
		afficheCharge ("Scripts chargés !",1);
		setTimeout(function(){chargeImages();},50);
	}
}

function imageChargee(texte)
{
				nbImagesChargees++;
				afficheCharge ("Chargement image "+texte,2);
				if (nbImagesChargees>39)
				{ 
					afficheCharge ("Images chargées !",2);
					afficheCharge ("Préparation du terrain ...",3);
					setTimeout(function(){initialise();},50);
				}
}

function chargeImages ()
{
	iobj[0]={nom:"vide",src:""};
	iobj[1]={nom:"arbre",src:"",dx:-186,dy:-320,ro:70,sais:0};
	iobj[2]={nom:"buisson",src:"",dx:-208,dy:-260,ro:80,sais:0};
	iobj[3]={nom:"rocher",src:"rocher1.png",dx:-42,dy:-10,ro:45,sais:0};
	iobj[4]={nom:"sanglier",src:"sanglier.png",src2:"sanglier2.png",dx:-65,dy:-82+25,dx2:-43,dy2:-93+25,ro:40,sais:0};
	iobj[5]={nom:"chèvre",src:"chevre.png",dx:-55,dy:-62,ro:40,sais:0}; // penser à rajouter 25 à dy
	iobj[6]={nom:"poisson mort",src:"poiss_mort.png",dx:-43,dy:5,ro:0,sais:0}; 
	iobj[7]={nom:"nénuphar",src:"nenuphar.png",dx:-43,dy:5,ro:0,sais:0}; 
	iobj[8]={nom:"roseaux",src:"roseaux.png",dx:-39,dy:-107+25,ro:20,sais:0}; 
	iobj[9]={nom:"ruche",src:"ruche.png",dx:-42,dy:-97+25,ro:60,sais:0}; 
	iobj[10]={nom:"pompe",src:"pompe.png",dx:-44,dy:-130+25,ro:60,sais:0};
	iobj[11]={nom:"puits",src:"puits.png",dx:-54,dy:-169+25,ro:60,sais:0}; 
	iobj[12]={nom:"mouton",src:"mouton.png",src2:"mouton2.png",dx:-68,dy:-83+25,dx2:-55,dy2:-111+25,ro:50,sais:0}; 
	iobj[13]={nom:"épouvantail",src:"epouvantail.png",dx:-43,dy:-187+25,ro:50,sais:0}; 
	iobj[14]={nom:"bonhomme de neige",src:"bonhomme.png",dx:-38,dy:-93+25,ro:50,sais:4};
	iobj[15]={nom:"composteur",src:"composteur.png",dx:-44,dy:-88+25,ro:60,sais:0};
	
	iobj[16]={nom:"pie (1)",src:"pie1.png"};
	iobj[17]={nom:"pie (2)",src:"pie2.png"};
	iobj[18]={nom:"pie (3)",src:"pie3.png"};

	iobj[19]={nom:"vide",src:""};
	iobj[20]={nom:"vide",src:""};
	
	iobj[21]={nom:"coquelicot",src:"coquelicot.png",sais:2};
	iobj[22]={nom:"chicorée",src:"chicoree.png",sais:2};
	iobj[23]={nom:"pâquerette",src:"paquerette.png",sais:1};	
	iobj[24]={nom:"champignon",src:"champi.png",sais:3};
	
	tplanches[0]={nom:"écran titre",src:"ecran_titre.jpg"};
	tplanches[1]={nom:"chasseur mécontent",src:"chasseur_mecontent.jpg"};
	tplanches[2]={nom:"chasseur content",src:"chasseur_content.jpg"};
	tplanches[3]={nom:"apiculteur proposant une ruche",src:"apiculteur_ruche.jpg"};
	tplanches[4]={nom:"apiculteur furieux",src:"apiculteur_furieux.jpg"};
	tplanches[5]={nom:"éleveur de truites",src:"eleveur_truites.jpg"};
	tplanches[6]={nom:"apiculteur mécontent",src:"apiculteur_mecontent.jpg"};
	tplanches[7]={nom:"berger furieux",src:"berger_furieux.jpg"};
	tplanches[8]={nom:"berger content",src:"berger_content.jpg"};
	tplanches[9]={nom:"voisin furieux",src:"voisin.jpg"};
	tplanches[10]={nom:"incendie",src:"incendie.jpg"};
	
	tcurseurs[0]={nom:"curseur déplacement",src:"move.png"};
	tcurseurs[1]={nom:"curseur rotation",src:"rotation.png"};
	tcurseurs[2]={nom:"curseur pioche",src:"pioche.png"};
	tcurseurs[3]={nom:"curseur pulv",src:"pulv.png"};
	tcurseurs[4]={nom:"curseur hache",src:"hache.png"};
	tcurseurs[5]={nom:"curseur beche",src:"beche.png"};
	tcurseurs[6]={nom:"curseur loupe",src:"loupe.png"};
	
	afficheCharge ("Chargement des tuiles",2);
	setTimeout(function(){
	for (var i=0;i<iobj.length;i++)
	{
		iobj[i].tpos=new Array;
		timg[i] = new Image();
		timg2[i] = new Image();
		var o=iobj[i];
		var nom=o.nom;
		if (!o.src=="")
		{
			timg[i].src = "images/tuiles/"+o.src;
			timg[i].onload = function(){
				imageChargee(nom);
			}
		}
		if ((typeof (o.src2) != 'undefined')&&(!o.src2==""))
		{
			timg2[i].src = "images/tuiles/"+o.src2;
			timg2[i].onload = function(){
				imageChargee(nom);
			}
		}
	}
	},50);
	
	afficheCharge ("Chargement des planches",2);
	setTimeout(function(){
	for (var i=0;i<tplanches.length;i++)
	{
		iplanches[i] = new Image();
		var o=tplanches[i];
		var nom=o.nom;
		if (!o.src=="")
		{
			iplanches[i].src = "images/planches/"+o.src;
			iplanches[i].onload = function(){
				imageChargee(nom);
			}
		}
	}
	},50);
	
	afficheCharge ("Chargement des curseurs",2);
	setTimeout(function(){
	for (var i=0;i<tcurseurs.length;i++)
	{
		icurseurs[i] = new Image();
		var o=tcurseurs[i];
		var nom=o.nom;
		if (!o.src=="")
		{
			icurseurs[i].src = "images/curseurs/"+o.src;
			icurseurs[i].onload = function(){
				imageChargee(nom);
			}
		}
	}
	},50);
}

function afficheCharge (texte,y)
{
	ctx2.textAlign="center";
	ctx2.font = "10px sans-serif";
	ctx2.clearRect(0,125+y*30-10,lcanvas,20);
	ctx2.fillText(texte,lcanvas/2,125+y*30);
}

function charge(nomf)
{
	afficheCharge ("Chargement du script "+nomf,1);
	var fileref=document.createElement('script');
	fileref.setAttribute("type","text/javascript");
	//fileref.async = true;
	fileref.setAttribute("src","scripts/"+nomf+".js");
	var js=document.getElementsByTagName("head")[0].appendChild(fileref);
    js.onload = function () {
		etape_suivante();
	}


}




function affiche()
{
	if (affichageEnCours) {return false;}
	affichageEnCours=true;
	setTimeout(function(){	
	gazon();
	afficheObjets();
	affichageEnCours=false;
	},1);
}

function affiche_sans()
{
	if (affichageEnCours) {return false;}
	affichageEnCours=true;
	gazon();
	afficheObjets();
	affichageEnCours=false;
}


function resize()
{
	if (!demar) {return false;}
	console.log ("redimension");
	lcanvas=window.innerWidth;
	hcanvas=window.innerHeight;
	ccan.width  = lcanvas;
	ccan.height = hcanvas;
	ccan1.width  = lcanvas;
	ccan1.height = hcanvas;
	ccan2.width  = lcanvas;
	ccan2.height = hcanvas;
	ccan3old.width  = lcanvas;
	ccan3old.height = hcanvas;
	ccant.width  = lcanvas;
	ccant.height = hcanvas;
	
	canvscore.width  = lcanvas;
	canvscore.height  = hcanvas;
	
	canvois.width  = lcanvas;
	canvois.height  = hcanvas;
	
	ccanm.width  = lcanvasmessage;
	ccanm.height = hcanvas;
	ccanm.style.left = Math.round(lcanvas/2-lcanvasmessage/2)+"px";
	ccanm.style.top = Math.round(hcanvas/2-hcanvasmessage/2)+"px";
	
	hcanvq=Math.round(hcanvas-hbandeau-10);
	lcanvq=Math.round(hcanvq*4/3);
	canvq.width  = lcanvq;
	canvq.height  = hcanvq;
	canvq.style.left = Math.round(lcanvas/2-lcanvq/2)+"px";
	canvq.style.top = Math.round(hbandeau+5)+"px";

	ccanstatut.style.top = (hcanvas-hStatusBar)+"px";
	
	if (scoreAffiche==1)
	{
		afficheScore();
	}
	else if (scoreAffiche==2)
	{
		bilanEcolo();
	}
	else if (scoreAffiche==3)
	{
		bilanFinancier();
	}
	else
	{
		affiche();
		rafrOverlay();
	}
	
	if (nQuestion>0)
	{
		if (nQuestion>50)
		{
			afficheQuestionImage(nQuestion);
		}
	}
	
	if (nQuestion<0)
	{
		if (nQuestion==-1)
		{ecranDAccueil();}
		else if ((nQuestion<-50)&&(nQuestion>-90))
		{
			planche (nQuestion);
		}
		else
		{
			document.body.style.cursor="default";
			attenteReponse=false;
			canvq.style.display="none";	
			nQuestion=0;
		}
	}
}