﻿function caseVide(x,y)
{
	//if ((x<0)||(x>imax)||(y<0)||(y>jmax))
	//{return false;}
	return (tobj[x][y].id==0);
}

function bougeObjet1(x,y)
{
	if (caseVide(x,y)) {return false;} // rien dans la case
	var t=tobj[x][y];
	var idObj=t.id;
	
	if ((idObj!=3)&&(idObj!=9)&&(idObj!=10)&&(idObj!=13)&&(idObj!=14)&&(idObj!=15))
	{
		//objet pas bougeable
		return false;
	}
	
	objetADeplacer=t;
	return true;
}

function pivoteObjet(x,y)
{
	if (caseVide(x,y)) {return false;} // rien dans la case
	var t=tobj[x][y];
	var idObj=t.id;
	
	if ((idObj!=3)&&(idObj!=9)&&(idObj!=10)&&(idObj!=13)&&(idObj!=14)&&(idObj!=15))
	{
		//objet pas pivotable
		return false;
	}
	
	// on pivote
	tobj[x][y].flip=Math.round(-tobj[x][y].flip);
	return true;
}

function creeObjet (x,y,o)
{
	if (o==1) {return false;}
	var t=new Object;
	var ida=iobj[o].tpos.length;
	t.id=o;
	t.ida=ida;
	t.x=x;
	t.y=y;
	var cap=Math.random()*6.28;
	var v=Math.random()/10;
	var xx=0;
	var yy=0;
	if (Math.random()>0.5) {t.flip=-1} else {t.flip=1} ;
	tobj[x][y]=t;
	var de100=Math.floor(Math.random()*100)+1;
	iobj[o].tpos.push({x:x,y:y,xx:xx,yy:yy,v:v,cap:cap,p:true,de100:de100,ida:ida,flip:t.flip});
}

function deplace_obj_io (x,y,o,io)
{
	var x0=Math.round(iobj[o].tpos[io].x);
	var y0=Math.round(iobj[o].tpos[io].y);
	var t=new Object;
	var n=-1;
	
	t=tobj[x0][y0];
	
	
	// on change x et y dans t
	t.x=x;
	t.y=y;
	
	// on récupère le flip au cas où il ait été modifié
	t.flip=iobj[o].tpos[io].flip;
	
	// on le rajoute dans tobj[x][y]
	tobj[x][y]=t;
	tobj[x0][y0]={id:0};
	
	// on change les coordonnées dans tpos
	iobj[o].tpos[io].x=x;
	iobj[o].tpos[io].y=y;	

}

function aff_obj2(i,j)
{
	if ((i<0)||(i>imax)||(j<0)||(j>jmax))
	{
		return false;
	}
	var o=new Object();
	var t=new Object();
	var idd=0;
	var dx=0;
	var dy=0;
	
	t=tobj[i][j];
	
	if (t.id>0)
	{

		x=x0+i*(50/zf)-j*(50/zf)+xpos*50/zf;
		y=y0+j*(25/zf)+i*(25/zf)+ypos*25/zf;
		
		if ((x<(lcanvas+180/zf))&&(x>(-180/zf))&&(y<(hcanvas+600/zf))&&(y>150/zf))
		{
			dz=alt_case(i,j)/zf;
		
			idd=t.id;
			if (idd<3) // arbre ou buisson
			{
				ida=t.ida;
				if ((((action==2)||(action==4))&&(idd==1)&&(!iobj[1].tpos[ida].souche)) || (((action==5))&&(idd==2)))
				{
					//grande croix rouge au pied de l'arbre ou du buisson
					ctx2.save();
					ctx2.strokeStyle="red";
					ctx2.lineWidth=4/zf;
					ctx2.translate (x,y);
					ctx2.beginPath();
					ctx2.moveTo (-50/zf,25/zf-tz[i][j+1]/zf);	
					ctx2.lineTo (50/zf,25/zf-tz[i+1][j]/zf);	
					ctx2.stroke();
					ctx2.beginPath();
					ctx2.moveTo (0,0-tz[i][j]/zf);	
					ctx2.lineTo (0,50/zf-tz[i+1][j+1]/zf);	
					ctx2.stroke();
					ctx2.restore();
				}
			}
			else
			{
				// pas arbre
				ctx2.lineWidth=1/zf;
				ctx2.strokeStyle="black";
				io=iobj[idd];
				
				img=timg[t.id];
				dx=io.dx/zf;
				dy=io.dy/zf;

				ctx2.save();
				ctx2.translate (x,y);
				ctx2.scale(t.flip, 1);
				//ctx2.globalCompositeOperation="xor";
				ctx2.beginPath();
				ctx2.strokeRect (dx,dy-dz,img.naturalWidth/zf,img.naturalHeight/zf);	
				ctx2.stroke();
				
				ctx2.restore();
			}
			
		}
	} // t.length>0
}


function afficheObjets ()
{
	var dx=50/zf;
	var dy=25/zf;
	var dxombre=0;
	var dyombre=0;
	var ddx=0;
	var ddy=0;
	var o=new Object();
	var t=new Object();
	var id=0;
	var ida=0;
	var r=0;
	var sais=0;
	var flip=1;
	
	var etat=0;
	var nImage=0;
	var nCanv=0;

	// variables pour les hautes herbes et fleurs
	var x2=0;
	var y2=0;
	var xh=0;
	var yh=0;
	var hh=0;
	var fl=0;
	var dhx=0;
	var w=0;
	var ii=0;
	var th=new Array();
	var bonneSaison=0;
	
	ctx1.clearRect(0,0,lcanvas,hcanvas);
		
	afficheFleurs();
	

	calcPoissMorts();
	
	for (var i=0;i<=imax;i++) {
		for (var j=0;j<=jmax;j++) {
		
			t=tobj[i][j];
			
			x=x0+i*(50/zf)-j*(50/zf);
			x=x+xpos*50/zf;
			y=y0+j*(25/zf)+i*(25/zf);
			y=y+ypos*25/zf;
			dz=alt_case(i,j)/zf;
									
									
			if ((!deplace)&&(desherbant<=0))
			{
				//hautes herbes
				th=tHerbe[i][j];
				if (th.length>1)
				{
					w=2/zf;
					ctx1.lineWidth=w;
					for (ii=0;ii<th.length;ii++)
					{
						ctx1.strokeStyle=th[ii].coul;
						xh=th[ii].xx/zf;
						yh=th[ii].yy/zf;
						hh=th[ii].h/zf;
								
						x2=x+ xh*(50)- yh*(50);
						y2=y+25/zf+ yh*(25)+ xh*(25);
											
						dhx=hh*th[ii].dx/zf;	
						
						ctx1.beginPath();
						ctx1.moveTo(x2+dhx,y2-hh-dz);
						ctx1.lineTo(x2,y2-dz);
						ctx1.stroke();
					}
				}// fin hautes herbes
								
			}// fin hautes herbes si pas déplace et pas de désherhant
			
			//cloture
			if (cloture)
			{
				if (i==0)
				{
					ctx1.strokeStyle="#662200";
					ctx1.lineWidth=4/zf;
					ctx1.beginPath();
					ctx1.moveTo(x,y+dy-tz[i][j]/zf);
					ctx1.lineTo(x,y+dy-tz[i][j]/zf-80/zf);
					if (j<jmax)
					{
						ctx1.lineTo(x-dx,y+dy*2-tz[i][j+1]/zf-80/zf);
						ctx1.moveTo(x,y+dy-tz[i][j]/zf-60/zf);
						ctx1.lineTo(x-dx,y+dy*2-tz[i][j+1]/zf-60/zf);
						ctx1.moveTo(x,y+dy-tz[i][j]/zf-40/zf);
						ctx1.lineTo(x-dx,y+dy*2-tz[i][j+1]/zf-40/zf);
						ctx1.moveTo(x,y+dy-tz[i][j]/zf-20/zf);
						ctx1.lineTo(x-dx,y+dy*2-tz[i][j+1]/zf-20/zf);
					}
					ctx1.stroke();
				}
				if (((j==0)||(j==jmax))&&((tz[i][j]+flood0*nivCrue)>0))
				{
					ctx1.strokeStyle="#662200";
					ctx1.lineWidth=4/zf;
					ctx1.beginPath();
					ctx1.moveTo(x,y+dy-tz[i][j]/zf);
					ctx1.lineTo(x,y+dy-tz[i][j]/zf-80/zf);
					ctx1.lineTo(x+dx,y+dy*2-tz[i+1][j]/zf-80/zf);
					ctx1.moveTo(x,y+dy-tz[i][j]/zf-60/zf);
					ctx1.lineTo(x+dx,y+dy*2-tz[i+1][j]/zf-60/zf);
					ctx1.moveTo(x,y+dy-tz[i][j]/zf-40/zf);
					ctx1.lineTo(x+dx,y+dy*2-tz[i+1][j]/zf-40/zf);
					ctx1.moveTo(x,y+dy-tz[i][j]/zf-20/zf);
					ctx1.lineTo(x+dx,y+dy*2-tz[i+1][j]/zf-20/zf);

					ctx1.stroke();
				}
			}
							
			//objets	
			id=t.id;			
			if (id>0)
			{
				
				if ((x<(lcanvas+180/zf))&&(x>(-180/zf))&&(y<(hcanvas+600/zf))&&(y>150/zf))
				{

				
					ida=t.ida;
					io=iobj[id];
					sais=io.sais;
											
					//nénu
					if (id==7) //nénuphar
					{	
						var de100=io.tpos[ida].de100;
						if (de100>cNenuMax) {id=0;}
						dz=Math.random()*3/zf-1/zf;
					}
					
					if (id==6) //poisson mort
					{	
						var de100=io.tpos[ida].de100;
						if (de100>cPoissMortsMax) {id=0;}
						dz=Math.random()*3/zf-1/zf;
					}
					
					
					if (id==1) // c'est un arbre
					{
						var tt=iobj[1].tpos[ida];
						ep=tt.epTronc;
						//ombre le soleil au Sud
						ctx1.save();
						xombre=x;
						yombre=y-dz+15/zf;
						xombre=xombre-io.ro/zf/5;
						yombre=yombre-io.ro/zf/10;
						if (tt.souche) {r=10+ep/2;} else {r=10+ep;}
						ctx1.translate (xombre,yombre);
						ctx1.beginPath();
						ctx1.fillStyle="rgba(0,0,0,0.1)";
						ctx1.scale(1, 0.5);
						ctx1.arc(0,20/zf,r/zf,0,2*Math.PI);
						ctx1.fill();
						ctx1.restore();
						var ccanArbre=tCanvArbre[ida];
						// dessin de l'arbre
						ddx=(-(lcanvarbre/2)-50)/zf+35/zf+ep/4/zf;
						ddy=(-(hcanvarbre)+25)/zf+ep/4/zf;

						ctx1.drawImage (ccanArbre,0,0,lcanvarbre,hcanvarbre,x+ddx,y+ddy-dz,lcanvarbre/zf,hcanvarbre/zf);	
						
						// dessin des insectes
						if ((!deplace)&&(tt.inse>0.5)&&(tt.etat>0))
						{
							for (var ist=0;ist<((tt.inse-0.5)*20);ist++)
							{
								ctx1.fillStyle="#002200";
								ctx1.fillRect(x-Math.random()*io.tpos[ida].haut/8/zf + io.tpos[ida].haut/16/zf ,y-dz-Math.random()*io.tpos[ida].haut/4/zf,4/zf,4/zf);
							}
						}
					}
					
					if (id==2) // c'est un buisson
					{
						etat=io.tpos[ida].etat;
						espece=io.tpos[ida].espece;
						nCanv=io.tpos[ida].nCanv;//numéro du canvas
						//ombre le soleil au Sud
						ctx1.save();
						xombre=x;
						yombre=y-dz+15/zf;
						xombre=xombre-io.ro/zf/5;
						yombre=yombre-io.ro/zf/10;
						r=60;
						ctx1.translate (xombre,yombre);
						ctx1.beginPath();
						ctx1.fillStyle="rgba(0,0,0,0.05)";
						ctx1.scale(1, 0.5);
						ctx1.arc(0,20/zf,r/zf,0,2*Math.PI);
						ctx1.fill();
						ctx1.restore();
						if (saison==4) {nImage=1;} else {nImage=0;}
						if (etat==-1) {nImage=2;}
						var ccanbuisson=tCanvBuisson[espece][nCanv][nImage];
						// dessin du buisson
						ddx=(-(lcanvasbuisson/2)-50)/zf+25/zf;
						ddy=(-(hcanvasbuisson)+30)/zf;
						ctx1.drawImage (ccanbuisson,0,0,lcanvasbuisson,hcanvasbuisson,x+ddx+r/2/zf,y+r/4/zf+ddy-dz,lcanvasbuisson/zf,hcanvasbuisson/zf);	
					}
					
					if ((id>2)&((sais==0)||(saison==sais))) // c'est un objet autre
					{
						if ((id==12)||(id==4)) // sanglier ou mouton
						{
							x+=io.tpos[ida].xx*(50/zf)-io.tpos[ida].yy*(50/zf);
							y+=io.tpos[ida].yy*(25/zf)+io.tpos[ida].xx*(25/zf);
							var cap=Math.round(io.tpos[ida].cap/(Math.PI/2));
							if ((cap==0)||(cap==4))
							{
								flip=-1;
								img=timg[id];
								dxombre=io.dx/zf;
								dyombre=io.dy/zf;
							}							
							else
							if (cap==1)
							{
								flip=1;
								img=timg[id];
								dxombre=io.dx/zf;
								dyombre=io.dy/zf;
							}
							else
							if (cap==2)
							{
								flip=-1;
								img=timg2[id];
								dxombre=io.dx2/zf;
								dyombre=io.dy2/zf;
							}
							else
							if (cap==3)
							{
								flip=1;
								img=timg2[id];
								dxombre=io.dx2/zf;
								dyombre=io.dy2/zf;
							}
							
						}
						else
						{
							flip=t.flip;
							img=timg[id];
							dxombre=io.dx/zf;
							dyombre=io.dy/zf;
						}		
						
						//ombre le soleil au Sud
						ctx1.save();
						xombre=x;
						yombre=y-dz+15/zf;
						xombre=xombre-io.ro/zf/5;
						yombre=yombre-io.ro/zf/10;
						ctx1.translate (xombre,yombre);
						ctx1.beginPath();
						ctx1.fillStyle="rgba(0,0,0,0.1)";
						ctx1.scale(1, 0.5);
						ctx1.arc(0,20/zf,io.ro/zf,0,2*Math.PI);
						ctx1.fill();
						ctx1.restore();
						
						// dessin de l'objet raster
						ctx1.save();
						//x-=io.dx/zf;
						//y-=io.dy/zf;
						ctx1.translate (x,y);
						ctx1.scale(flip, 1);
						ctx1.drawImage (img,0,0,img.naturalWidth,img.naturalHeight,dxombre,dyombre-dz,img.naturalWidth/zf,img.naturalHeight/zf);	
						
						ctx1.restore();
						
					}
						
					
				}
			} // id>0
			
		}
	}	
}

function supprObjet(id,ida)
{
	if (!iobj[id].tpos[ida].p) {return false;}
	var t2=iobj[id].tpos[ida];
	var x=t2.x;
	var y=t2.y;
	tobj[x][y]={id:0};
	iobj[id].tpos[ida].p=false;
}
