﻿function creeOiseauxDebut()
{
	//création des oiseaux
	for (i=0;i<nbMaxOiseaux;i++)
	{
		rajouteOiseau();
	}
}

function calculEpouv()
{
	nbEpouvantails=0;
	for (i=0;i<iobj[13].tpos.length;i++)
	{
		if (iobj[13].tpos[i].p) {nbEpouvantails++;}
	}
	var nbEpouvEffectifs=nbEpouvantails-habitudeEpouvantails;
	if (nbEpouvEffectifs<0) {nbEpouvEffectifs=0;}
	nbEpouvEffectifs=nbEpouvEffectifs+1;
	pOiseaux=1/(nbEpouvEffectifs);
}

function deprecieEpouv()
{
	var nbEpouvEffectifs=nbEpouvantails-habitudeEpouvantails;
	if (nbEpouvEffectifs>1)
	{
		habitudeEpouvantails++;
	}
}

function rajouteOiseau()
{
	if (nOiseau>=nbMaxOiseaux)
	{
		return false;
	}
	// on tire un arbre au hasard
	var io=iobj[1].tpos;
	var n=Math.floor(Math.random()*io.length);
	var t=io[n];
	if ((!t.p)||(t.etat<0)) {return false;}
	var hArbre=t.haut/5;
	var o=new Object();
	o={z:1000,t:0,vol:true,arrive:true};
	calcNewX0(o);
	tOiseau[nOiseau]=o;
	nOiseau++;
	return false;
}

function calcNewX0 (o)
{
	// calcul du coin de départ
	var coin=Math.floor(Math.random()*4);
	if (coin==0) {o.x=0;o.y=Math.floor(Math.random()*jmax);}
	if (coin==1) {o.x=imax;o.y=Math.floor(Math.random()*jmax);}
	if (coin==2) {o.y=jmax;o.x=Math.floor(Math.random()*imax);}
	if (coin==3) {o.y=0;o.x=Math.floor(Math.random()*imax);}
	
	// calcul de l'arbre de destination
	// on tire un arbre au hasard
	var io=iobj[1].tpos;
	var n=Math.floor(Math.random()*io.length);
	var t=io[n];
	var tentatives=0;
	// on recommence jusqu'à en trouver un présent
	while ((!t.p)&&(tentatives<20))
	{
		tentatives++;
		n=Math.floor(Math.random()*io.length);
		t=io[n];	
	}
	var hArbre=t.haut/5;
	o.x1=t.x+Math.random()-0.5;
	o.y1=t.y;
	o.z1=alt_case(t.x,t.y)+hArbre;
	
	o.z=1000;
	o.flip=((o.x-o.y)<(o.x1-o.y1));
}

function calcNewX1 (o)
{
	var coin=Math.floor(Math.random()*4);
	if (coin==0) {o.x1=0;o.y1=Math.floor(Math.random()*jmax);}
	if (coin==1) {o.x1=imax;o.y1=Math.floor(Math.random()*jmax);}
	if (coin==2) {o.y1=jmax;o.x1=Math.floor(Math.random()*imax);}
	if (coin==3) {o.y1=0;o.x1=Math.floor(Math.random()*imax);}
	o.z1=1000;
	o.flip=((o.x-o.y)<(o.x1-o.y1));
}


function stopOiseau(nOi)
{
		var io=iobj[1].tpos;
		var n=Math.floor(Math.random()*io.length);
		var t=io[n];
		var hArbre=t.haut/5;
		var o=new Object();
		o={x1:t.x+Math.random()-0.5,y1:t.y,z1:alt_case(t.x,t.y)+hArbre,x:0,y:0,z:1000,t:0,vol:true,arrive:true};
		calcNewX0(o);
		tOiseau[nOi]=o;
}

function animOiseau()
{
	if (attenteReponse) {return false;}
	if (saison!=2) {return false;}
	if (deplace) {ctxois.clearRect(0,0,lcanvas,hcanvas);return false;}
	if (myCanvas.style.display=="none") {return false;};
	if (fonduEnCours) {return false;}
	if (nMenu1>=0) {return false;}
	if (action>0) {return false;}
		
	ctxois.clearRect(0,0,lcanvas,hcanvas);
	for (var i=0;i<(nbMaxOiseaux*pOiseaux);i++)
	{
		var o=tOiseau[i];	
				
		if (!o.vol) {return false;}
		
		o.t++;
		
		if (o.arrive)
		{
			var dx=o.x1-o.x;
			var dy=o.y1-o.y;
			var dz=o.z1-o.z;
			

			if (Math.abs(dx)>10) {dx=10*Math.abs(dx)/dx;}
			if (Math.abs(dy)>10) {dy=10*Math.abs(dy)/dy;}
			
			o.x=o.x+dx/5;
			o.y=o.y+dy/5;
			o.z=o.z+dz/10;
			
			if (Math.abs(dx+dy+dz)<10)
			{
				o.arrive=false;
				o.t=0;
				calcNewX1(o);
			}

		}
		else
		{
			var dx=o.x1-o.x;
			var dy=o.y1-o.y;
			var dz=o.z1-o.z;
	
			if (o.t>20)
			{
				var v=(o.t-18)/40;
				if (v>2) {v=2;}
				var rxy=dy/dx;
				dx=Math.abs(dx)*v/dx;
				dy=rxy*dx;
				dz=v*40;
				if (dz>100) {dz=100;}
				o.x=o.x+dx;
				o.y=o.y+dy;
				o.z=o.z+dz;	
			}
		}
		//o.x=((o.x)*9+(o.x1))/10;
		//o.y=((o.y)*9+(o.y1))/10;
		//o.z=((o.z)*9+alt_case(o.x1,o.y1)+100)/10;
				
		//ombre
		var c=calcCoords(o.x,o.y,alt_case(Math.round(o.x),Math.round(o.y)));
		ctxois.fillStyle="rgba(0,0,0,0.1)";
		var r=15/zf;
		
		ctxois.save();
		if (!o.arrive) 
		{var alpha=(o.t/2)-15;if (alpha<1) {alpha=1;} ctxois.globalAlpha=1/alpha;}
		else
		{var alpha=(o.t/2);if (alpha>1) {alpha=1;} ctxois.globalAlpha=1/alpha;}
		ctxois.translate (c.x-r,c.y-r*2);
		ctxois.scale (1,0.5);
		ctxois.beginPath();
		ctxois.arc (0,0,r,0,Math.PI*2);
		ctxois.closePath();
		ctxois.fill();
		ctxois.restore();
		
		//oiseau
		if (o.t%2==0)
		{
			var img=timg[16];
		}
		else
		{
			var img=timg[17]
		}
		if ((!o.arrive)&&(o.t<15))
		{
			var img=timg[18]
		}
		c=calcCoords(o.x,o.y,o.z);
		ctxois.fillStyle="rgb(0,0,100)";
		ctxois.save();
		if (!o.arrive) 
		{var alpha=(o.t/2)-15;if (alpha<1) {alpha=1;} ctxois.globalAlpha=1/alpha;}
		else
		{var alpha=(o.t/2);if (alpha>1) {alpha=1;} ctxois.globalAlpha=1/alpha;}
		
		ctxois.translate (c.x-20,c.y-5);
		
		if (o.flip)
		{
			ctxois.scale (-1,1);
		}
		ctxois.drawImage(img,0,0,img.naturalWidth,img.naturalHeight,0,0,img.naturalWidth/zf,img.naturalHeight/zf);
		ctxois.restore();
		
		tOiseau[i]=o;
		
		if ( (!o.arrive)&& ((o.x<0)||(o.x>imax)||(o.y<0)||(o.y>imax)||(o.z>1000)) ) {stopOiseau(i);}

	}
}


function calcCoords(i,j,z)
{
	var coords=new Object;

	var x=x0+i*(50/zf)-j*(50/zf)+xpos*50/zf;
	var y=y0+j*(25/zf)+i*(25/zf)+ypos*25/zf+75/zf;
	var dz=z/zf;
	
	coords.x=x;
	coords.y=y-dz;
	
	return coords;
}