﻿function progres(pourcent)
{
	ctx2.fillStyle="rgba(0,0,0,0.5)";
	ctx2.clearRect (0,0,lmenu,hbandeau);
	ctx2.fillRect (0,0,lmenu,hbandeau);
	ctx2.strokeStyle="rgb(200,200,200)";
	ctx2.lineWidth=5;
	ctx2.beginPath();
	ctx2.arc (lmenu/2,hbandeau/2,hbandeau/3,0,2*Math.PI*pourcent);
	ctx2.stroke();
}

function afficheCurseur(x,y)
{
	var img=null;
	if (action==1)
	{
		img=icurseurs[5]; // beche
		ctx2.drawImage (img,x-60,y-55);
		return false;
	}
	if (action==2)
	{
		img=icurseurs[4]; // hache
		ctx2.drawImage (img,x-2,y-12);
		return false;
	}
	if (action==3)
	{
		img=icurseurs[3]; //pulv
		ctx2.drawImage (img,x-2,y-2);
		return false;
	}
	if ((action==4)||(action==5))
	{
		img=icurseurs[2]; //pioche
		ctx2.drawImage (img,x,y-34);
		return false;
	}
	if ((action==10)||(action==11))
	{
		var id=objetAAcheter;
		img=timg[id];
		io=iobj[id];
		dx=io.dx/zf;
		dy=io.dy/2/zf;
		
		ctx2.drawImage (img,0,0,img.naturalWidth,img.naturalHeight,x+dx,y+dy*2,img.naturalWidth/zf,img.naturalHeight/zf);
		return false;	
	}
	if (action==20) //pivoter
	{
		img=icurseurs[1];
		ctx2.drawImage (img,x-16,y-16);
		return false;
	}
	
	if (action==21) //bouger (1ère étape : curseur croix move)
	{
		img=icurseurs[0]; //move
		ctx2.drawImage (img,x-16,y-16);
		return false;
	}	
	
	if (action==22) //bouger (2ème étape : le curseur c'est l'objet sur la croix)
	{
		img=icurseurs[0]; //move
		ctx2.drawImage (img,x-16,y-16);
		var id=objetADeplacer.id;
		img=timg[id];
		io=iobj[id];
		dx=io.dx/zf;
		dy=io.dy/2/zf;
		
		ctx2.drawImage (img,0,0,img.naturalWidth,img.naturalHeight,x+dx,y+dy*2,img.naturalWidth/zf,img.naturalHeight/zf);
		return false;
	}	
	if (action==30) //analyser un arbre
	{
		img=icurseurs[6]; //loupe
		ctx2.drawImage (img,x-16,y-16);
		return false;
	}
}

function messageEtat (texte,xxt)
{
	if (!debug) {return false;}
	xxt=xxt*100;
	ctxsta.clearRect(xxt,0,100,hStatusBar);
	
	ctxsta.font = "10px sans-serif";
	ctxsta.textAlign="left";
	ctxsta.fillStyle="white";	
	ctxsta.fillText (texte,5+xxt,hStatusBar/2);
	console.log (texte);
}

function rafrOverlay()
{
	if (fonduEnCours) {return false;}
	var marge=20;

	ctx2.clearRect(0,0,lcanvas,hcanvas);
	ctx2.fillStyle="rgba(0,0,0,0.5)";
	ctx2.font = "italic 20px sans-serif";
	ctx2.textAlign="right";
	//crédits
	ctx2.fillText ("Auteur : Philippe Cosentino",lcanvas-marge,hcanvas-marge);
	
	//menu cesser
	if (action>0)
	{
		ctx2.fillStyle="rgba(0,0,0,0.5)";
		ctx2.fillRect (lmenu+5,hbandeau+5,lmenu2,100);
		ctx2.font = "20px sans-serif";
		ctx2.fillStyle="#FFFFFF";
		ctx2.textAlign="center";
		if (action==1) {var texte="DE PLANTER";}
		if (action==2) {var texte="DE COUPER";}
		if (action==3) {var texte="DE TRAITER";}
		if (action==10) {var texte="DE PLACER";}
		if (action==11) {var texte="DE PLACER";}
		if (action==20) {var texte="DE PIVOTER";}
		if (action==21) {var texte="DE DEPLACER";}
		if (action==22) {var texte="DE DEPLACER";}
		if (action==30) {var texte="D'ANALYSER";}
		if ((action==4)||(action==5)) {var texte="D'ARRACHER";}
		ctx2.fillText ("CESSER "+texte,lmenu+5+lmenu2/2,hbandeau+60);
	}
	
	//menu gauche
	ctx2.fillStyle="rgba(0,0,0,0.5)";
	ctx2.fillRect (0,0,lmenu,hcanvas);
	ctx2.fillRect (lmenu+1,0,lcanvas-lmenu-1,hbandeau);
	ctx2.textAlign="left";
	ctx2.font = "20px sans-serif";
	for (var i=0;i<menu1.length;i++)
	{
		ctx2.clearRect (0,50+i*50,lmenu,1);
		if ((menu1[i].dispo)&&(action<=0)&&(!partieFinie)&&(etapeCA=="")) {ctx2.fillStyle="white";} else {ctx2.fillStyle="rgb(150,150,150)";}
		ctx2.fillText (menu1[i].label,marge,82+50*i);
	}
	
	//titre
	ctx2.font = "italic 30px sans-serif";
	ctx2.textAlign="center";
	ctx2.fillStyle="white";
	ctx2.fillText ("Sim'Agro",lcanvas/2+lmenu/2,34);
	
	if (debug)
	{
		//affichage infos debug
		ctx2.font = "10px sans-serif";
		ctx2.textAlign="left";
		ctx2.fillText("souris (x,y)="+pos_x+","+pos_y,lmenu+marge,10);
		ctx2.fillText("curseur (i,j,alt)="+icur+","+jcur+","+alt_case(icur,jcur),lmenu+marge,30);
		
		ctx2.fillText("nitsol="+Math.round(nitratesSol*100)/100,lmenu+600,10);
		ctx2.fillText("coefnitr="+Math.round(coefNitrates*100)+"%",lmenu+700,10);
		ctx2.fillText("niteau="+Math.round(nitratesRiv*100)/100,lmenu+600,30);
		
		if (pipetteobj>0) {ctx2.fillText("pipette="+iobj[pipetteobj].nom,lmenu+marge,50);}
		
		var c=tobj[icur][jcur];

		if (c.id==1) 
		{
			var ida=c.ida;
			ctx2.fillText("ida="+ida+" etat="+iobj[1].tpos[ida].etat+" age="+iobj[1].tpos[ida].age+" vit="+Math.round(iobj[1].tpos[ida].vit*100)+"% conc="+Math.round(iobj[1].tpos[ida].concurrence*100)+"% haut="+Math.round(iobj[1].tpos[ida].haut),lmenu+marge+150,30);
			ctx2.fillText("fruits="+Math.round(iobj[1].tpos[ida].fruits*100)+"%",lmenu+marge+150,45);
		}
		
		if (c.id==2) 
		{
			var ida=c.ida;
			ctx2.fillText("ida="+ida+" etat="+iobj[2].tpos[ida].etat,lmenu+marge+100,30);
		}
	}
	// menu droit
	var marge=15;
	ctx2.fillStyle="rgba(0,0,0,0.5)";
	ctx2.fillRect (lcanvas-lmenu,hbandeau,lmenu,200);
	
	//argent
	ctx2.fillStyle="white";
	ctx2.font = "italic 20px sans-serif";
	ctx2.textAlign="right";
	
	var texte=nombreLisible(argent)+" €";
	ctx2.clearRect (lcanvas-lmenu-115-1,0,1,hbandeau);
	ctx2.fillText("Solde :",lcanvas-lmenu-marge,20);
	ctx2.fillText(texte,lcanvas-lmenu-marge,42);
	
	// calendrier
	ctx2.font = "italic 20px sans-serif";
	ctx2.textAlign="left";
	ctx2.clearRect (lcanvas-lmenu-1,0,1,hbandeau);
	texte="";
	if (annee==1) {texte="1ère";} else {texte=annee+"ème";}
	texte+=" année";
	ctx2.fillText(texte,lcanvas-lmenu+marge,20);
	ctx2.fillText("("+nomSaison[saison]+")",lcanvas-lmenu+marge,42);
	ctx2.clearRect (lcanvas-lmenu-1,50,lmenu,1);
	ctx2.clearRect (lcanvas-lmenu-1,100,lmenu,1);
	ctx2.clearRect (lcanvas-lmenu-1,150,lmenu,1);
	ctx2.clearRect (lcanvas-lmenu-1,200,lmenu,1);
	ctx2.font = "18px sans-serif";
	if ((action==0)&&(!partieFinie)&&(etapeCA=="")) {ctx2.fillStyle="white";} else {ctx2.fillStyle="rgb(150,150,150)";}
	ctx2.fillText ("SAISON",lcanvas-lmenu+marge,73);
	ctx2.fillText ("SUIVANTE (S)",lcanvas-lmenu+marge,93);
	ctx2.fillStyle="rgb(150,150,150)";
	if (annee>1) {ctx2.fillStyle="white";} else {ctx2.fillStyle="rgb(150,150,150)";}
	ctx2.fillText ("BILAN",lcanvas-lmenu+marge,123);
	ctx2.fillText ("FINANCIER",lcanvas-lmenu+marge,143);
	if (annee>1) {ctx2.fillStyle="white";} else {ctx2.fillStyle="rgb(150,150,150)";}
	ctx2.fillText ("BILAN",lcanvas-lmenu+marge,173);
	ctx2.fillText ("ECOLOGIQUE",lcanvas-lmenu+marge,193);
	
	ctx2.fillText ("SCORE",lcanvas-lmenu+marge,223);
	ctx2.fillText ("GLOBAL",lcanvas-lmenu+marge,243);
	
	// menu ouvert
	if (nMenu1>=0)
	{
		afficheMenu();
	}
	
}
