﻿function bilanFinancier()
{
	scoreAffiche=3;
		
	var hcanvas2=hcanvas-hbandeau*1.5;
	canvscore.style.display="block";
	myCanvas.style.display="none";
	ctxscore.fillStyle="rgba(0,0,0,0.5)";
	ctxscore.clearRect(0,0,lcanvas,hcanvas);
	ctxscore.fillRect(0,0,lcanvas,hbandeau);
	ctxscore.fillRect(0,hcanvas-hbandeau/2,lcanvas,hbandeau/2);
	
	//titre
	ctxscore.font = "italic 30px sans-serif";
	ctxscore.textAlign="center";
	ctxscore.fillStyle="white";
	var texte=(annee-1)+" année";
	if (annee>2) {texte+="s";}
	ctxscore.fillText ("Bilan financier au bout de "+texte,lcanvas/2,34);
	
	//texte bas
	ctxscore.font = "italic 16px sans-serif";
	ctxscore.textAlign="center";
	ctxscore.fillStyle="white";
	ctxscore.fillText ("Cliquer sur le graphique pour retourner au jeu",lcanvas/2,hcanvas-8);
	
	ctxscore.strokeStyle="black";
	ctxscore.lineWidth=0.5;
	ctxscore.beginPath();
	ctxscore.moveTo(lcanvas/3,hbandeau);
	ctxscore.lineTo(lcanvas/3,hcanvas2+hbandeau);
	ctxscore.stroke();
	
	//graphique
	ctxscore.save();
	ctxscore.translate(Math.round(lcanvas/3),hbandeau);
		
	var haut=hcanvas2;
	var large=lcanvas*2/3;

	var ht=haut/24;

	ht=Math.floor(ht);
	ctxscore.font = "bold "+ht+"px sans-serif";
	ctxscore.fillStyle= "black";
	ctxscore.textAlign="left";
	
	ctxscore.fillText ("GRAPHIQUE",ht,ht*1.5);
	
	var xgr0=Math.round(large/18)+0.5;
	var xgrMax=Math.round(large-ht*5)+0.5;
	var ygr0=Math.round(haut-ht*2)+0.5;
	var ygrMax=Math.round(ht*4)+0.5;
	var tFl=Math.round(ht/2);
	var tGr=Math.round(tFl/2);
	var xgrMax2=xgrMax-Math.round(tFl*2);
	var ygrMax2=ygrMax+Math.round(tFl*2);
	var lgr=xgrMax2-xgr0;
	var hgr=-(ygrMax2-ygr0);
	
	// tracé des axes
	ctxscore.strokeStyle="black";
	ctxscore.lineWidth=0.5;
	ctxscore.beginPath();
	ctxscore.moveTo(xgr0,ygr0);
	ctxscore.lineTo(xgrMax,ygr0);
	ctxscore.lineTo(xgrMax-tFl,ygr0-tFl);
	ctxscore.moveTo(xgrMax,ygr0);
	ctxscore.lineTo(xgrMax-tFl,ygr0+tFl);
	ctxscore.stroke();
	
	ctxscore.beginPath();
	ctxscore.moveTo(xgr0,ygr0);
	ctxscore.lineTo(xgr0,ygrMax);
	ctxscore.lineTo(xgr0-tFl,ygrMax+tFl);
	ctxscore.moveTo(xgr0,ygrMax);
	ctxscore.lineTo(xgr0+tFl,ygrMax+tFl);
	ctxscore.stroke();
	
	var tabCourbe=new Array;
	tabCourbe[1]=tabArgent;
	tabCourbe[2]=tabRevRec;
	tabCourbe[3]=tabRevApi;
	tabCourbe[4]=tabRevTot;
	tabCourbe[5]=tabDepenses;
	var argentMax=0;
	for (var j=1;j<6;j++)
	{
		for (var i=0;i<annee;i++)
		{
			if ((tabCourbe[j][i]>argentMax)&&(tabCoche[j]>0))
			{
				argentMax=tabCourbe[j][i];
				anMaxArgent=i;
			}
		}
	}
	
	
	// tracé des graduations
	htgr=Math.round(ht/2);
	ctxscore.font = htgr+"px sans-serif";
	ctxscore.textAlign="center";
	
	// abscisses
	for (var i=0;i<annee;i++)
	{
		var xgr=Math.round((i/(annee-1))*lgr)+xgr0+0.5;
		ctxscore.strokeStyle="rgb(230,230,230)";
		ctxscore.beginPath();
		ctxscore.moveTo(xgr,ygr0);
		ctxscore.lineTo(xgr,ygr0+tGr);
		ctxscore.stroke();
		ctxscore.beginPath();
		ctxscore.moveTo(xgr,ygr0);
		ctxscore.lineTo(xgr,ygrMax);
		ctxscore.stroke();
		if ((annee<20)||((i%2)==0))
		{
			ctxscore.fillText (i,xgr,ygr0+htgr*1.5);
		}
	}
	
	
	// ordonnées
	ctxscore.textAlign="right";
	
	if (argentMax>5000)
	{	
		for (var i=0;i<=Math.floor(argentMax/1000);i++)
		{ // graduation par 100
			var ygr=ygr0-hgr*(i*1000/argentMax);
			ctxscore.strokeStyle="rgb(200,200,200)";
			ctxscore.beginPath();
			ctxscore.moveTo(xgr0,ygr);
			ctxscore.lineTo(xgrMax,ygr);
			ctxscore.stroke();
			ctxscore.strokeStyle="black";
			ctxscore.beginPath();
			ctxscore.moveTo(xgr0,ygr);
			ctxscore.lineTo(xgr0+tGr,ygr);
			ctxscore.stroke();
			if (argentMax<10000)
			{
				ctxscore.fillText (i*1000,xgr0-htgr*0.5,ygr+htgr*0.25);
			}
			else if (argentMax<20000)
			{
				if ((i%2)==0) {ctxscore.fillText (i*1000,xgr0-htgr*0.5,ygr+htgr*0.25);}
			}
			else
			{
				if ((i%5)==0) {ctxscore.fillText (i*1000,xgr0-htgr*0.5,ygr+htgr*0.25);}
			}
		}
	}
	else
	{
		for (var i=0;i<=Math.floor(argentMax/100);i++)
		{ // graduation par 100
			var ygr=ygr0-hgr*(i*100/argentMax);
			ctxscore.strokeStyle="rgb(200,200,200)";
			ctxscore.beginPath();
			ctxscore.moveTo(xgr0,ygr);
			ctxscore.lineTo(xgrMax,ygr);
			ctxscore.stroke();
			ctxscore.strokeStyle="black";
			ctxscore.beginPath();
			ctxscore.moveTo(xgr0,ygr);
			ctxscore.lineTo(xgr0+tGr,ygr);
			ctxscore.stroke();
			if (argentMax<1000)
			{
				ctxscore.fillText (i*100,xgr0-htgr*0.5,ygr+htgr*0.25);
			}
			else if (argentMax<2000)
			{
				if ((i%2)==0) {ctxscore.fillText (i*100,xgr0-htgr*0.5,ygr+htgr*0.25);}
			}
			else
			{
				if ((i%5)==0) {ctxscore.fillText (i*100,xgr0-htgr*0.5,ygr+htgr*0.25);}
			}		
		}
	}
	
	// titres axes
	ctxscore.textAlign="center";
	ctxscore.fillText ("Somme (en €)",xgr0,ygrMax-htgr);
	ctxscore.textAlign="left";
	ctxscore.fillText ("Année",xgrMax+htgr*0.5,ygr0+htgr*0.25);
	
	// tracé de la courbe
	ctxscore.lineWidth=1;
	for (c=1;c<6;c++)
	{
		if (tabCoche[c]>0)
		{
			ctxscore.strokeStyle=tabCoulCourbe[c];
			ctxscore.beginPath();
			for (var i=0;i<annee;i++)
			{
				var xgr=Math.round((i/(annee-1))*lgr)+xgr0+0.5;
				var ygr=ygr0-hgr*(tabCourbe[c][i]/argentMax);

				if (i==0) 
				{
					ctxscore.moveTo(xgr,ygr);
				}
				else
				{
					ctxscore.lineTo(xgr,ygr);
				}
			}	
			ctxscore.stroke();
		}
	}
	
	
	ctxscore.restore();
	
	//légende
	ctxscore.save();
	ctxscore.translate(0,hbandeau);
		
	var large=lcanvas*2/3;

	var ht=haut/24;
	
	var hCaseLeg=Math.round(ht*0.8);

	ht=Math.floor(ht);
	ctxscore.font = "bold "+ht+"px sans-serif";
	ctxscore.fillStyle= "black";
	ctxscore.textAlign="left";
	
	ctxscore.fillText ("LEGENDE",ht,ht*1.5);
	
	tLeg1=haut*2/8+ht*0.4;
	tLeg2=haut*3/8+ht*0.4;
	tLeg3=haut*4/8+ht*0.4;
	tLeg4=haut*5/8+ht*0.4;
	tLeg5=haut*6/8+ht*0.4;
	
	ctxscore.font = ht+"px sans-serif";
	var decLeg=ht*2+hCaseLeg;
	ctxscore.fillStyle= tabCoulCourbe[1];
	ctxscore.fillText ("Solde",decLeg,tLeg1);
	ctxscore.fillStyle= tabCoulCourbe[2];
	ctxscore.fillText ("Revenus récoltes",decLeg,tLeg2);
	ctxscore.fillStyle= tabCoulCourbe[3];
	ctxscore.fillText ("Revenus apicoles",decLeg,tLeg3);
	ctxscore.fillStyle= tabCoulCourbe[4];
	ctxscore.fillText ("Revenus totaux",decLeg,tLeg4);
	ctxscore.fillStyle= tabCoulCourbe[5];
	ctxscore.fillText ("Dépenses totales",decLeg,tLeg5);
	
	// cases
	ctxscore.fillStyle= "black";
	ctxscore.lineWidth=1;
	for (var i=2;i<7;i++)
	{
		ctxscore.beginPath();
		ctxscore.rect (Math.round(ht*1.5)+0.5,Math.round(haut*i/8-hCaseLeg/2)+0.5,hCaseLeg,hCaseLeg);	
		if (tabCoche[(i-1)]>0) {ctxscore.fillRect (Math.round(ht*1.5)+3.5,Math.round(i*haut/8-hCaseLeg/2)+3.5,hCaseLeg-6,hCaseLeg-6);}
		ctxscore.stroke();
	}
	
	ctxscore.restore();
	
}

function bilanEcolo()
{
	scoreAffiche=2;
	var anSai=(annee-1)*4+(saison-1);
		
	var hcanvas2=hcanvas-hbandeau*1.5;
	canvscore.style.display="block";
	myCanvas.style.display="none";
	ctxscore.fillStyle="rgba(0,0,0,0.5)";
	ctxscore.clearRect(0,0,lcanvas,hcanvas);
	ctxscore.fillRect(0,0,lcanvas,hbandeau);
	ctxscore.fillRect(0,hcanvas-hbandeau/2,lcanvas,hbandeau/2);
	
	//titre
	ctxscore.font = "italic 30px sans-serif";
	ctxscore.textAlign="center";
	ctxscore.fillStyle="white";
	var texte=(annee-1)+" année";
	if (annee>2) {texte+="s";}
	ctxscore.fillText ("Bilan écologique au bout de "+texte,lcanvas/2,34);
	
	//texte bas
	ctxscore.font = "italic 16px sans-serif";
	ctxscore.textAlign="center";
	ctxscore.fillStyle="white";
	ctxscore.fillText ("Cliquer sur cet écran pour retourner au jeu",lcanvas/2,hcanvas-8);
	
	
	if (aucuneAction)
	{
		var ht=Math.floor(hcanvas/16);
		ctxscore.textAlign="center";
		ctxscore.fillStyle="black";
		ctxscore.font = "bold "+ht+"px sans-serif";
		ctxscore.fillText ("Vous n'êtes pas encore intervenu sur votre terrain,",lcanvas/2,hcanvas/2-ht);
		ctxscore.fillText ("il n'y a rien à évaluer.",lcanvas/2,hcanvas/2+ht);
		return false;
	}
	
	ctxscore.strokeStyle="black";
	ctxscore.lineWidth=0.5;
	ctxscore.beginPath();
	ctxscore.moveTo(lcanvas/2,hbandeau);
	ctxscore.lineTo(lcanvas/2,hcanvas2+hbandeau);
	ctxscore.stroke();
	
	//#####################
	//##   biodiversité  ##
	//#####################
	ctxscore.save();
	ctxscore.translate(0,hbandeau);
		
	var haut=hcanvas2/2;
	var large=lcanvas/2;

	var ht=haut/24;

	ht=Math.floor(ht);
	ctxscore.font = "bold "+ht+"px sans-serif";
	ctxscore.fillStyle= "black";
	ctxscore.textAlign="left";
	
	var yt=wrapText(ctxscore, "BILAN BIODIVERSITE", ht*3, ht*4, large-ht*6, ht*2);
	var texte="La biodiversité est la diversité naturelle des êtres vivants.";
	ctxscore.font = "italic "+ht+"px sans-serif";
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);

	var score=0;
	//fleurs
	ctxscore.font = ""+ht+"px sans-serif";
	var moyenneSaisonsAvecFleurs=saisonsAvecFleurs/anSai;
	if (moyenneSaisonsAvecFleurs>0.9)
	{
		ctxscore.fillStyle="#007700";
		texte="En limitant l'usage des désherbants vous avez maintenu une flore messicole (coquelicots, bleuets etc ...) dans votre verger.";
		score+=4;
	}
	else
	if (moyenneSaisonsAvecFleurs>0.5)
	{
		ctxscore.fillStyle="#777700";
		texte="Par vos désherbages, vous avez limité le développement des plantes messicoles (coquelicots etc ...), diminuant ainsi la biodiversité.";
		score+=2;
	}
	else
	{
		ctxscore.fillStyle="#770000";
		texte="Vos désherbages fréquents ont quasiment fait disparaître les plantes messicoles du paysage, réduisant considérablement la biodiversité.";
	}	
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);	

	//oiseaux
	var moyennepOiseauxCumule=pOiseauxCumule/anSai;
	
	if (moyennepOiseauxCumule>0.9)
	{
		ctxscore.fillStyle="#007700";
		texte="Vous avez maintenu une avifaune (oisaux) abondante.";
		score+=4;
	}
	else
	if (moyennepOiseauxCumule>0.4)
	{
		ctxscore.fillStyle="#777700";
		texte="Vous avez limité la population d'oiseaux dans votre verger, dans des limites raisonnables, respectant ainsi la biodiversité.";
		score+=3;
	}
	else
	{
		ctxscore.fillStyle="#770000";
		texte="Vous avez très fortement réduit la population d'oiseaux dans votre verger, réduisant d'autant la biodiversité.";
	}	
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);	
	
	//insecticides
	var moyenneInsecticides=insecticidesCumule/anSai;
	if (moyenneInsecticides<0.1)
	{
		ctxscore.fillStyle="#007700";
		texte="En limitant au minimum l'usage d'insecticides, vous avez respecté les populations d'insectes, et notamment les abeilles.";
		score+=4;
	}
	else
	if (moyenneInsecticides<1)
	{
		ctxscore.fillStyle="#777700";
		texte="Vous avez limité la population d'insectes dans votre verger, dans des limites raisonnables, respectant ainsi la biodiversité.";
		score+=2;
	}
	else
	{
		ctxscore.fillStyle="#770000";
		texte="Vous avez très fortement réduit la population d'insectes dans votre verger, réduisant d'autant la biodiversité.";
	}	
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);	
	
	//poissons morts
	var moyennePoissonsMorts=poissonsMortsCumule/anSai;
	if (moyennePoissonsMorts<0.5)
	{
		ctxscore.fillStyle="#007700";
		texte="De plus, vos pratiques n'ont quasiment pas eu d'impact négatif sur la faune de la rivière.";
		score+=4;
	}
	else
	if (moyennePoissonsMorts<5)
	{
		ctxscore.fillStyle="#777700";
		texte="Vos rejets de pesticides et de nitrates ont hélas impacté négativement la faune de la rivière.";
		score+=2;
	}
	else
	{
		ctxscore.fillStyle="#770000";
		texte="Vos pratiques ont eu des conséquences désastreuses sur la biodiversité de la rivière.";
	}	
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);	
	
	//buissons
	var moyenneBuissons=nbBuissonsCumule/anSai-annee;
	if ((moyenneBuissons>25)&&(nBuissons>25))
	{
		ctxscore.fillStyle="#007700";
		texte="Enfin, vous avez laissé se développer la garrigue dans votre verger, contribuant positivement au maintien de la biodiversité.";
		score+=4;
	}
	else
	if ((moyenneBuissons>10)&&(nBuissons>10))
	{
		ctxscore.fillStyle="#777700";
		texte="Enfin, vous avez certes réduit la garrigue mais sans la faire disparaître de votre verger.";
		score+=3;
	}
	else
	{
		ctxscore.fillStyle="#770000";
		texte="Vous avez quasiment fait disparaître la garrigue de votre verger.";
	}	
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);	

	ctxscore.font = "bold "+ht+"px sans-serif";
	ctxscore.fillStyle="black";
	var yt=wrapText(ctxscore, "Votre score de biodiversité est de "+Math.round(score)+"/20", ht*4, yt+ht*3, large-ht*6, ht*1.5);
	
	ctxscore.restore();
	// fin biodiversité
	
	//#####################
	//##conso & rejets   ##
	//#####################
	ctxscore.save();
	ctxscore.translate(lcanvas/2,hbandeau);

	ctxscore.font = "bold "+ht+"px sans-serif";
	ctxscore.fillStyle= "black";
	ctxscore.textAlign="left";
	
	var pompe=false;
	// on recherche si une pompe est réellement présente 
	for (var i=0;i<iobj[10].tpos.length;i++)
	{
		if (iobj[10].tpos[i].p)
		{
			pompe=true;
		}
	}
	
	var yt=wrapText(ctxscore, "BILAN CONSOMMATION D'EAU", ht*3, ht*4, large-ht*6, ht*2);	
	ctxscore.font = ""+ht+"px sans-serif";
	var texte="Depuis le début de votre exploitation vous avez consommé "+consoTotaleEau+"m3 d'eau du réseau.";
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);
	if (pompe)
	{
		ctxscore.fillStyle="#007700";
		texte="En installant une pompe et un forage, vous avez considérablement réduit cette consommation.";
		var yt=wrapText(ctxscore, texte, ht*4, yt+ht*2, large-ht*6, ht*1.5);
	}
	
		
	// REJETS
	ctxscore.font = "bold "+ht+"px sans-serif";
	ctxscore.fillStyle="black";
	var yt=wrapText(ctxscore, "BILAN REJETS", ht*3, yt+ht*4, large-ht*6, ht*2);
	//nitrates
	var texte="La présence d'un excès de nitrates dans l'eau est un indice de pollution d'origine agricole. En général un amendement excessif (engrais) en est la cause.";
	ctxscore.font = "italic "+ht+"px sans-serif";
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);
	ctxscore.font = ""+ht+"px sans-serif";
	var moyenneNitrates=Math.round(nitratesEauCumul/anSai);
	texte1="Depuis que vous exploitez votre verger, le taux moyen de nitrates dans l'eau de la rivière le bordant est de "+moyenneNitrates+" mg/L. ";
	if (moyenneNitrates<10)
	{
		ctxscore.fillStyle="#007700";
		texte2="Cette teneur n'est certes pas nulle, mais vous n'en êtes pas le seul responsable. Vous avez fait de votre mieux pour la maintenir au plus bas.";
	}
	else
	if (moyenneNitrates<25)
	{
		ctxscore.fillStyle="#777700";
		texte2="Cette teneur n'est pas satisfaisante. Certes vous n'en êtes pas le seul responsable, mais vous auriez pu davantage maîtriser vos amendements.";
	}
	else
	{
		ctxscore.fillStyle="#770000";
		texte2="Cette teneur est si élevée que l'eau n'est pratiquement plus potable. Vos amendements excessifs en sont responsables !";
	}	
	var yt=wrapText(ctxscore, texte1, ht*4, yt+ht*3, large-ht*6, ht*1.5);	
	var yt=wrapText(ctxscore, texte2, ht*4, yt+ht*2, large-ht*6, ht*1.5);	
	score=11-(moyenneNitrates/4);
	if (score<0) {score=0;}
	if (score>10) {score=10;}
	var scoreNitrates=score;
	
	//pesticides
	ctxscore.fillStyle= "black";
	var texte="Les pesticides sont des substances utilisées pour tuer des organismes considérés comme nuisibles (rongeurs, insectes, champignons, 'mauvaises' herbes ...). Les fongicides, insecticides et désherbants sont des pesticides.";
	ctxscore.font = "italic "+ht+"px sans-serif";
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);
	ctxscore.font = ""+ht+"px sans-serif";
	
	var moyennePesticides=pesticidesCumul/anSai;
	if (moyennePesticides<0.2)
	{
		texte="En moyenne, vos rejets de pesticides ont été très faibles";
		if (pesticidesEau>1)
		{
			ctxscore.fillStyle="#777700";
			texte+=", mais leur taux dans le milieu ces derniers temps n'est pas satisfaisant.";
			var scorePesticides=9-(pesticidesEau*2);
		}
		else
		{
			ctxscore.fillStyle="#007700";
			texte+=". Félicitations.";
			var scorePesticides=10;
		}
	}
	else
	if (moyennePesticides<2)
	{
		ctxscore.fillStyle="#777700";
		texte="Vos rejets de pesticides ont par moment fragilisé les écosystèmes, notamment ceux de la rivière.";
		var scorePesticides=(2-moyennePesticides)*5;
	}
	else
	{
		ctxscore.fillStyle="#770000";
		texte="Vos rejets de pesticides ont durablement empoisonné la faune et la flore !";
		var scorePesticides=0;
	}	
	var yt=wrapText(ctxscore, texte, ht*4, yt+ht*3, large-ht*6, ht*1.5);	

	if (scorePesticides<0) {scorePesticides=0;}
		
	scorePesticides=Math.round(scorePesticides);
	
	ctxscore.font = "bold "+ht+"px sans-serif";
	ctxscore.fillStyle="black";
	var yt=wrapText(ctxscore, "Votre score 'rejets' est de "+Math.round(scoreNitrates+scorePesticides)+"/20", ht*4, yt+ht*3, large-ht*6, ht*1.5);
	
	ctxscore.restore();
}

function afficheScore()
{
	var anSai=(annee-1)*4+(saison-1);
	scoreAffiche=1;
	var scoreSocial=25;
	
	var moyenneCloture=saisonsCloture/anSai; // de 0 à 1
	var scoreChasseurs=(1-moyenneCloture)*20;
	
	var moyenneSatisApic=satisApic/anSai;
	if (moyenneSatisApic>1) {moyenneSatisApic=1;}
	if (moyenneSatisApic<0) {moyenneSatisApic=0;}
	var scoreApic=moyenneSatisApic*30;
	
	var scorePech=20-mecontPecheurs*5;
	if (scorePech<0) {scorePech=0;}
	
	var scoreBerger=satisBerger*50/anSai;
	if (scoreBerger>20) {scoreBerger=20;}
	if (scoreBerger<0) {scoreBerger=0;}
	
	var scoreLimites=10-mecontLimites*2;
	if (scoreLimites<0) {scoreLimites=0;}
	
	scoreSocial=scoreBerger+scorePech+scoreApic+scoreChasseurs+scoreLimites;
	scoreSocial=Math.round(scoreSocial);
	if (scoreSocial>100) {scoreSocial=100;}
	if (scoreSocial<0) {scoreSocial=0;}
	
	console.log ('score berger='+scoreBerger+' apic='+scoreApic+" pecheur="+scorePech+" chasseurs="+scoreChasseurs);
	
	//calcul du score écnomique
	// rendement attendu=1000 par saison à partir de la 10ème année
	var benef=argent-10000;
	var benefMoyen=benef/anSai;
	//benefMoyen <0 => score de 0 à 20
	if (benefMoyen<0)
	{
		score=Math.exp(benefMoyen/100)*20;
	}
	if (benefMoyen==0)
	{
		score=20;
	}
	if (benefMoyen>0)
	{
		score=benefMoyen/1000*80+20;
	}
	
	//console.log (benefMoyen+" "+score);
	
	if (score>100) {score=100;}
	if (score<0) {score=0;}
	
	
	var scoreEcono=Math.round(score);
	
	// calcul du score de biodiversité
	var score=0;
	//fleurs
	var moyenneSaisonsAvecFleurs=saisonsAvecFleurs/anSai;
	if (moyenneSaisonsAvecFleurs>0.9)
	{	score+=4;	}
	else
	if (moyenneSaisonsAvecFleurs>0.5)
	{	score+=2;	}
	//oiseaux
	var moyennepOiseauxCumule=pOiseauxCumule/anSai;
	if (moyennepOiseauxCumule>0.8)
	{	score+=4;	}
	else
	if (moyennepOiseauxCumule>0.4)
	{	score+=2;	}
	//insecticides
	var moyenneInsecticides=insecticidesCumule/anSai;
	if (moyenneInsecticides<0.1)
	{	score+=4;	}
	else
	if (moyenneInsecticides<0.3)
	{	score+=2;	}
		//poissons morts
	var moyennePoissonsMorts=poissonsMortsCumule/anSai;
	if (moyennePoissonsMorts<10)
	{	score+=4;	}
	else
	if (moyennePoissonsMorts<30)
	{	score+=2;	}
	//buissons
	var moyenneBuissons=nbBuissonsCumule/anSai-annee;
	if (moyenneBuissons>25)
	{	score+=4;	}
	else
	if (moyenneBuissons>10)
	{	score+=3;	}
	scoreBiodiversite=score;
	// fin calcul score biodiversité
	
	
	// calcul score rejets
	//nitrates
	var moyenneNitrates=Math.round(nitratesEauCumul/anSai);
	score=11-(moyenneNitrates/4);
	if (score<0) {score=0;}
	if (score>10) {score=10;}
	var scoreNitrates=score;
	
	var moyennePesticides=pesticidesCumul/anSai;
	if (moyennePesticides<1)
	{
		if (pesticidesEau>1)
		{
			var scorePesticides=9-(pesticidesEau*2);
		}
		else
		{
			var scorePesticides=10;
		}
		
	}
	else
	if (moyennePesticides<4)
	{
		var scorePesticides=(4-moyennePesticides)*2;
	}
	else
	{
		var scorePesticides=0;
	}	
	
	scorePesticides=Math.round(scorePesticides);
	
	var scoreEcolo=Math.round(scoreBiodiversite*2+scoreNitrates*3+scorePesticides*3);
	
	if (scoreEcolo>100) {scoreEcolo=100;}
	if (scoreEcolo<0) {scoreEcolo=0;}
	
	var hcanvas2=hcanvas-hbandeau*1.5;
	canvscore.style.display="block";
	myCanvas.style.display="none";
	ctxscore.fillStyle="rgba(0,0,0,0.5)";
	ctxscore.clearRect(0,0,lcanvas,hcanvas);
	ctxscore.fillRect(0,0,lcanvas,hbandeau);
	ctxscore.fillRect(0,hcanvas-hbandeau/2,lcanvas,hbandeau/2);
	
	if (aucuneAction)
	{
		var ht=Math.floor(hcanvas/16);
		ctxscore.textAlign="center";
		ctxscore.fillStyle="black";
		ctxscore.font = "bold "+ht+"px sans-serif";
		ctxscore.fillText ("Vous n'êtes pas encore intervenu sur votre terrain,",lcanvas/2,hcanvas/2-ht);
		ctxscore.fillText ("il n'y a rien à évaluer.",lcanvas/2,hcanvas/2+ht);
		return false;
	}

	ctxscore.strokeStyle="black";
	ctxscore.lineWidth=0.5;
	ctxscore.beginPath();
	ctxscore.moveTo(lcanvas/2,hbandeau);
	ctxscore.lineTo(lcanvas/2,hcanvas2+hbandeau);
	ctxscore.moveTo(0,hbandeau+hcanvas2/2);
	ctxscore.lineTo(lcanvas,hbandeau+hcanvas2/2);
	ctxscore.stroke();
	
	//titre
	ctxscore.font = "italic 30px sans-serif";
	ctxscore.textAlign="center";
	ctxscore.fillStyle="white";
	var texte=(annee-1)+" année";
	if (annee>2) {texte+="s";}
	ctxscore.fillText ("Score global au bout de "+texte,lcanvas/2,34);
	
	//texte bas
	ctxscore.font = "italic 16px sans-serif";
	ctxscore.textAlign="center";
	ctxscore.fillStyle="white";
	ctxscore.fillText ("Cliquer sur cet écran pour retourner au jeu",lcanvas/2,hcanvas-8);
	
	//diagramme développement durable
	ctxscore.save();
	ctxscore.translate(0,hbandeau);
	
	var haut=hcanvas2/2;
	var large=lcanvas/2;
	
	ctxscore.textAlign="center";
	ctxscore.font = "italic 16px sans-serif";
	
	var x0=large/2;
	var y0=haut/2;
	var a=large/2;
	var b=haut/2;
	if (a>b)
	{
		var r1=haut/6;
		var r2=haut/4;
		var ht=haut/26;
	}
	else
	{
		var r1=large/6;
		var r2=large/4;
		var ht=large/26;
	}
	ht=Math.floor(ht);
	ctxscore.font = "italic "+ht+"px sans-serif";

	var x1=x0;
	var y1=y0-r1;
	var x2=x0+Math.cos(-Math.PI/6)*r1;
	var y2=y0-Math.sin(-Math.PI/6)*r1;
	var x3=x0+Math.cos(7*Math.PI/6)*r1;
	var y3=y0-Math.sin(7*Math.PI/6)*r1;
	var y4=y0+5*r2/8;
	var y5=y0+r2/2;
	var y6=y0-r2;
	var y7=y0-r2/3;
	var x4=x0-r2;
	var x5=x0+r2;
	var x6=x0-r2/2;
	var x7=x0+r2/2;
	
	var y8=haut*13/14;
	
	ctxscore.fillStyle="rgba(100,255,100,0.3)";
	ctxscore.beginPath();
	ctxscore.arc(x1,y1,r2,0,2*Math.PI);
	ctxscore.closePath();
	ctxscore.fill();
	ctxscore.stroke();
	
	ctxscore.fillStyle="rgba(255,255,255,0.3)";
	ctxscore.beginPath();
	ctxscore.arc(x1,y1,r2*90/100,0,2*Math.PI);
	ctxscore.fill();
	
	ctxscore.fillStyle="rgba(100,100,255,0.3)";
	ctxscore.beginPath();
	ctxscore.arc(x2,y2,r2,0,2*Math.PI);
	ctxscore.closePath();
	ctxscore.fill();
	ctxscore.stroke();
	
	ctxscore.fillStyle="rgba(255,255,255,0.3)";
	ctxscore.beginPath();
	ctxscore.arc(x2,y2,r2*90/100,0,2*Math.PI);
	ctxscore.fill();

	ctxscore.fillStyle="rgba(255,100,100,0.3)";
	ctxscore.beginPath();
	ctxscore.arc(x3,y3,r2,0,2*Math.PI);
	ctxscore.closePath();
	ctxscore.fill();
	ctxscore.stroke();
	
	ctxscore.fillStyle="rgba(255,255,255,0.3)";
	ctxscore.beginPath();
	ctxscore.arc(x3,y3,r2*90/100,0,2*Math.PI);
	ctxscore.fill();
	

	ctxscore.fillStyle="black";
	ctxscore.fillText ("équitable",x0,y4+8);
	ctxscore.fillText ("SOCIAL",x4,y5+8);
	ctxscore.fillText ("ECONOMIQUE",x5,y5+8);
	ctxscore.fillText ("ECOLOGIQUE",x0,y6+8);
	ctxscore.fillText ("vivable",x6,y7+8);
	ctxscore.fillText ("viable",x7,y7+8);
	ctxscore.font = "italic bold "+ht+"px sans-serif";	
	ctxscore.fillText ("DURABLE",x0,y0+8+ht);
	
	ctxscore.font = "italic bold "+Math.round(ht*1.5)+"px sans-serif";	
	ctxscore.fillText ("LES 3 PILIERS DU DEVELOPPEMENT DURABLE",x0,y8);
	
	ctxscore.restore();	
	
	
	//texte piliers
	ctxscore.save();
	ctxscore.translate(0,hcanvas2/2+hbandeau);
	
	var texte="Le développement durable est une notion qui prend en compte des aspects environnementaux, sociaux et économiques."
	var texte2="Ainsi, le développement durable est un développement qui répond aux besoins du présent sans corrompre la capacité des générations futures à répondre à leurs propres besoins.";
	
	ctxscore.fillStyle="black";
	ctxscore.font = "italic "+Math.round(ht*1.5)+"px Trebuchet,sans-serif";
	ctxscore.textAlign= "left";
	var yt=wrapText(ctxscore, texte, ht*3, ht*4, large-ht*6, ht*2);
	var yt=wrapText(ctxscore, texte2, ht*3, yt+ht*4, large-ht*6, ht*2);
	
	ctxscore.restore();
	
	//triangle score
	ctxscore.save();
	ctxscore.translate(lcanvas/2,hbandeau);

	
	var x0=large/2;
	var y0=haut/2+haut/20;
	
	ctxscore.font = ""+ht+"px sans-serif";
	var r3=r1*5/2;
	var x1=x0;
	var y1=y0-r3;
	var x2=x0+Math.cos(-Math.PI/6)*r3;
	var y2=y0-Math.sin(-Math.PI/6)*r3;
	var x3=x0+Math.cos(7*Math.PI/6)*r3;
	var y3=y0-Math.sin(7*Math.PI/6)*r3;
	
	ctxscore.beginPath();
	ctxscore.moveTo (x0,y0);
	ctxscore.lineTo (x1,y1);
	ctxscore.stroke ();
	
	ctxscore.beginPath();
	ctxscore.moveTo (x0,y0);
	ctxscore.lineTo (x2,y2);
	ctxscore.stroke ();	

	ctxscore.beginPath();
	ctxscore.moveTo (x0,y0);
	ctxscore.lineTo (x3,y3);
	ctxscore.stroke ();
	
	ctxscore.fillStyle="black";
	ctxscore.fillText ("Ecologie",x0,y1-ht*2.5+8);
	ctxscore.fillText ("Economie",x2+ht/2,y2+ht*3/2+8);
	ctxscore.fillText ("Social",x3-ht/2,y3+ht*3/2+8);

	var x1=x0;
	var y1=y0-r3*scoreEcolo/100;
	var x2=x0+Math.cos(-Math.PI/6)*r3*scoreEcono/100;
	var y2=y0-Math.sin(-Math.PI/6)*r3*scoreEcono/100;
	var x3=x0+Math.cos(7*Math.PI/6)*r3*scoreSocial/100;
	var y3=y0-Math.sin(7*Math.PI/6)*r3*scoreSocial/100;
	
	ctxscore.fillStyle="rgba(100,100,100,0.3)";
	ctxscore.beginPath();
	ctxscore.moveTo (x1,y1);
	ctxscore.lineTo (x2,y2);
	ctxscore.lineTo (x3,y3);
	ctxscore.lineTo (x1,y1);
	ctxscore.closePath();
	ctxscore.stroke ();
	ctxscore.fill ();
	
	
	ctxscore.fillStyle="black";
	ctxscore.fillText (scoreEcolo,x0,y1-ht+8);
	ctxscore.fillText (scoreEcono,x2+ht,y2+8);
	ctxscore.fillText (scoreSocial,x3-ht,y3+8);

	ctxscore.font = "italic bold "+Math.round(ht*1.5)+"px sans-serif";		
	ctxscore.fillText ("VOTRE SCORE DANS CHACUN DES 3 PILIERS",x0,y8);
	
	ctxscore.restore();
	
	//texte explication score
	ctxscore.save();
	ctxscore.translate(lcanvas/2,hcanvas2/2+hbandeau);
	
	var texte="Le score économique est calculé à partir de la rentabilité de votre verger. Sa valeur n'est significative qu'en fin de partie.";
	var texte2="Le score écologique dépend de l'impact de votre pratique agricole sur l'environnement (nitrates, herbicide, insecticides etc ...)";
	var texte3="Le score social reflète la satisfaction ou le mécontentement des autres exploitants et des riverains.";
	
	ctxscore.fillStyle="black";
	ctxscore.font = "italic "+Math.round(ht*1.5)+"px Trebuchet,sans-serif";
	ctxscore.textAlign= "left";
	var yt=wrapText(ctxscore, texte, ht*3, ht*4, large-ht*6, ht*2);
	var yt=wrapText(ctxscore, texte2, ht*3, yt+ht*3, large-ht*6, ht*2);
	var yt=wrapText(ctxscore, texte3, ht*3, yt+ht*3, large-ht*6, ht*2);
	
	ctxscore.restore();
	
	
}

function fermeScore(event)
{
	pos_x = event.offsetX?(event.offsetX):event.pageX-document.getElementById("canvscore").offsetLeft;
	pos_y = event.offsetY?(event.offsetY):event.pageY-document.getElementById("canvscore").offsetTop;
	if (scoreAffiche==3)
	{
		// on vérifie si une case n'est pas cochée
		var hcanvas2=hcanvas-hbandeau*1.5;
		var haut=hcanvas2;
		var ht=haut/24;
		var hCaseLeg=Math.round(ht*0.8);
		ht=Math.floor(ht);
		var coche=0;
		if ((pos_x>(ht*1.5))&&(pos_x<(ht*1.5+hCaseLeg)))
		{
			for (var i=2;i<7;i++)
			{
				var yCL1=haut*i/8-hCaseLeg/2+hbandeau;
				var yCL2=yCL1+hCaseLeg;
				if ((pos_y>yCL1)&&(pos_y<yCL2))
				{
					coche=i-1;
				}
			}
		}
		tabCoche[coche]=Math.round(1-tabCoche[coche]);
		if ((coche>0)&&(coche<6)) {bilanFinancier();}
		if (pos_x<(canvscore.width/3)) {return false;}
	}
	
	scoreAffiche=0;
	canvscore.style.display="none";
	myCanvas.style.display="block";
	affiche();
	rafrOverlay();
}
